set xact_abort on
BEGIN TRAN


-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--   , 
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN 
	(
		SELECT D.[LINK], D.[CODE_TOFK], D.[INN],  [NUM] = ROW_NUMBER() OVER (PARTITION BY D.[CODE_TOFK], D.[INN] ORDER BY D.[LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS D
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 7
	) D	ON D.NUM = 1 AND
		D.[INN] = LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13) 
		AND
		D.[CODE_TOFK] = LEFT(ISNULL(LTRIM(RTRIM( b.[CODE])),''),20) 

WHERE
	b.IsFolder = 'false' --AND b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) >= 10
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[CODE])),''),20)) >= 4
GO

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN 
	(
		SELECT D.[LINK], D.[CODE_TOFK], [NUM] = ROW_NUMBER() OVER (PARTITION BY D.[CODE_TOFK] ORDER BY D.[LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS D
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 7
	) D	ON D.NUM = 1 AND
		D.[CODE_TOFK] = LEFT(ISNULL(LTRIM(RTRIM( b.[CODE])),''),20) 
WHERE
	b.IsFolder = 'false' --AND b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[CODE])),''),20)) >= 4
GO

--   
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN 
	(
		SELECT D.[LINK], D.[INN],  [NUM] = ROW_NUMBER() OVER (PARTITION BY D.[INN] ORDER BY D.[LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS D
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 7
	) D	ON D.NUM = 1 AND
		D.[INN] = LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13) 
WHERE
	b.IsFolder = 'false' --AND b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( b.[])),''),13)) >= 10
GO


--  
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	INNER JOIN 
	(
		SELECT D.[LINK], D.[FULL_NAME], NUM = ROW_NUMBER() OVER (PARTITION BY D.[FULL_NAME] ORDER BY D.[LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS D
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
				INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 7

	) D	ON D.NUM = 1 AND
		D.FULL_NAME = LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254)
WHERE
	b.IsFolder = 'false' --AND b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	
	AND LEN( LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254) ) > 1
GO

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	VED_LINK,
 	MAIN_LINK,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	UCHR_LINK,
 	CODE_TOFK,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE], [LINK_DEP],
 	[INSERTED_UIDS]) 
 	 OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
 	 INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_]
SELECT 
	CODE          = rtrim([{Variable_WorkDb}].dbo.XB_GET_NEXT_CCODE('DEPARTMENTS', 10, default)), 
	NAME        = LEFT(case when LEN(b.[Description]) > 0 THEN b.[Description] else b.[] END,50),
	FULL_NAME     = LEFT(case when LEN(b.[]) > 0 THEN b.[] ELSE b.[Description] END,254),
	INN           = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),13), 
 	KPP           = LEFT(ISNULL(LTRIM(RTRIM( b.[] )),''),9),
 	OKPO          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = RIGHT(ISNULL(LTRIM(RTRIM( b.Code )),''),4),
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	[LINK_DEP]    = [{Variable_WorkDb}].dbo.getOwnDepLink(),-- {LINK_DEP},
 	[INSERTED_UIDS]   = b.Ref
  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
  WHERE 
	b.IsFolder = 'false' AND  b.Code <> '' AND b.[Description] <> ''--b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)  
  ORDER BY B.Code

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_CAZN]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_CAZN]
SELECT
             = b.Code,
    = b.[Description],
  = CASE WHEN b.[Description] = '' THEN '  '
                    WHEN b.Code = '' THEN '  '
                    --WHEN b.DeletionMark = 'true' THEN '  ' 
                    END 
INTO [{Variable_TempDb}].dbo.[__JOURNAL_CAZN]
  FROM [{Variable_TempDb}].dbo.[CatalogObject|] b
  WHERE b.IsFolder = 'false' AND (b.Code = '' OR b.[Description] = '')--b.DeletionMark = 'true' OR 
ORDER BY 

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_CAZN', ISNULL(@iROWS_NOT_COPIED,0))
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]

--   
UPDATE D SET 
	D.TOFK_LINK = I.LINK
FROM
	{Variable_TempDb}.dbo.[CatalogObject|] O
	INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] OO ON OO.REF = O.REF
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = OO.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON O. = B.REF
	INNER JOIN (SELECT D.[LINK], D.[CODE_TOFK], NUM = ROW_NUMBER() OVER (PARTITION BY D.[CODE_TOFK] ORDER BY D.LINK)
					FROM  [{Variable_WorkDb}].dbo.DEPARTMENTS D
							INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF GR on GR.DEP_LINK = D.LINK
							INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS G on GR.GROUP_LINK = G.LINK and G.[SYS] = 7
					WHERE EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[CatalogObject|] WHERE LTRIM(RTRIM()) LIKE LTRIM(RTRIM(D.[CODE_TOFK]))) 
				) I ON I.NUM = 1 AND LTRIM(RTRIM(B.)) LIKE LTRIM(RTRIM(I.[CODE_TOFK]))	

WHERE
	D.TOFK_LINK IS NULL AND D.[LINK] IS NOT NULL

	
GO


GO
	   
  ---

    DECLARE @iGROUP_LINK INT, @IERROR INT
    SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
    WHERE dg.SYS = 7
    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT sb.link, @iGROUP_LINK
FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb
		WHERE
			NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link AND T.GROUP_LINK = @iGROUP_LINK)

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
	PRINT('  ' + convert(varchar(254),@iERROR) )
	RAISERROR('     ', 11,1)
END
		

COMMIT TRAN
