SET XACT_ABORT ON
BEGIN TRAN

USE [{Variable_TempDb}]
GO

----     

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_ADMIN_BS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_ADMIN_BS]

GO

CREATE TABLE [dbo].[__JOURNAL_ADMIN_BS] (
	[] varchar(max) ,
	[] VARCHAR(MAX) ,
 [] VARCHAR(MAX))
 
GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO


DECLARE @iROWCOUNT INT, @iROWS_NOT_COPIED INT

--      
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT DISTINCT D.LINK, b.Ref 
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] b
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] BU ON BU.REF = B.
	INNER JOIN 
	(
		SELECT 
			LINK		= d.LINK
			,CODE		= d.CODE
			--,BUDG_LINK	= ab.BUDG_LINK
			,BUDG_CODE	= ISNULL(d2.CODE,'')
			,NUM = ROW_NUMBER() OVER (PARTITION BY d.CODE, d2.CODE ORDER BY d.CODE, d2.CODE)	
		FROM 
			[{Variable_WorkDb}].dbo.DEPARTMENTS d
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF dgr ON dgr.DEP_LINK = d.LINK
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg ON dg.LINK = dgr.GROUP_LINK AND dg.[SYS] = 10	
			LEFT JOIN [{Variable_WorkDb}].dbo.ADMIN_BS ab ON ab.LINK_UP = d.LINK
			LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d2 ON d2.LINK = ab.BUDG_LINK
		WHERE
			D.LINK_DEP = [{Variable_WorkDb}].dbo.getOwnDepLink()	
	) D	ON D.NUM = 1 AND
		D.CODE = b.code AND D.BUDG_CODE = BU.CODE
WHERE
	b.DeletionMark = 'false'
	AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = b.Ref)	

--------------
INSERT INTO [{Variable_TempDb}].dbo.[__JOURNAL_ADMIN_BS]
	([], [], [])
SELECT 
 []          = ab.Code,
 [] = ab.,
 []      = '       '
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] ab
	INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T ON T.REF = AB.REF
	
SET @iROWS_NOT_COPIED = @@ROWCOUNT


----------
CREATE TABLE #ADMBS_LINK (CODE VARCHAR(10), [NAME] VARCHAR(50), LINK INT, [Ref] UNIQUEIDENTIFIER)

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	VED_LINK,
 	MAIN_LINK,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	UCHR_LINK,
 	CODE_TOFK,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE],LINK_DEP,
 	[INSERTED_UIDS]) 
 OUTPUT INSERTED.CODE, INSERTED.NAME, INSERTED.LINK, INSERTED.[INSERTED_UIDS]
	INTO #ADMBS_LINK
SELECT 
	CODE          = i.CODE, 
	[NAME]        = CASE WHEN i.[NAME] = '' THEN i.CODE ELSE i.NAME END,
	FULL_NAME     = CASE WHEN i.FULL_NAME = '' THEN i.CODE ELSE i.FULL_NAME END,
	INN           = '',
 	KPP           = '',
 	OKPO          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	[LINK_DEP]    = {Variable_WorkDb}.dbo.getOwnDepLink(),
 	i.ref
FROM
(
	  SELECT DISTINCT
	        RowNumber = ROW_NUMBER() OVER (PARTITION BY ab.Code, ab.[] ORDER BY ab.),
	        CODE          = RIGHT(ISNULL(LTRIM(RTRIM( ab.Code )),''),10), 
	        [NAME]        = LEFT(ISNULL(LTRIM(RTRIM( ab. )),''),50),
	        FULL_NAME     = LEFT(ISNULL(LTRIM(RTRIM( ab. )),''),254),
	        ab.ref
      FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] ab
	  WHERE 
		ab.DeletionMark = 'false' 
	    AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T WHERE T.[Ref] = ab.Ref)
) i
WHERE
    i.RowNumber = 1
		
set @iROWCOUNT = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_ADMIN_BS', @iROWS_NOT_COPIED)

------------
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] ([LINK], [Ref])
SELECT LINK, REF FROM #ADMBS_LINK

------------
INSERT INTO [{Variable_WorkDb}].dbo.ADMIN_BS (LINK_UP,BUDG_LINK,DATEB,DATEE)
SELECT DISTINCT
	LINK_UP       = al.LINK,
	BUDG_LINK     = TB.LINK,
	DATEB         = case left (ab., 1) when '0' then '19000101' else convert(datetime,ab.) end,
	DATEE         = convert(datetime,ab.)
FROM #ADMBS_LINK al
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] ab ON AL.REF = AB.REF
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] TB ON TB.REF = AB.

------------
DECLARE @iGROUP_LINK INT, @IERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 10

	INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
	SELECT al.link, @iGROUP_LINK
	FROM #ADMBS_LINK al
	
--   
UPDATE D SET [SUB_DEP] = (SELECT TOP 1 LINK FROM {Variable_WorkDb}.dbo.F_ADMIN_BS(DEFAULT) WHERE CODE = LTRIM(RTRIM(G.CODE)))
FROM
	{Variable_TempDb}.dbo.[CatalogObject|] O
	INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] OO ON OO.REF = O.REF
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = OO.LINK
	INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] G ON G.Ref = O.
WHERE
	D.[SUB_DEP] IS NULL	

--   
UPDATE D SET [SUB_DEP] = (SELECT TOP 1 LINK FROM {Variable_WorkDb}.dbo.F_ADMIN_BS(DEFAULT) WHERE CODE = LTRIM(RTRIM(G.CODE)))
FROM
	{Variable_TempDb}.dbo.[CatalogObject|] O
	INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] OO ON OO.REF = O.REF
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = OO.LINK
	INNER JOIN {Variable_TempDb}.dbo.[CatalogObject|] G ON RTRIM(ltrim(O.))<>'' and G.Ref = isnull(O.,newid())
WHERE
	D.[SUB_DEP] IS NULL


--     
	USE {Variable_TempDb}

	INSERT INTO [{Variable_WorkDb}].dbo.BUDGET_TYPE ([CODE], [SNAME], [NAME], [CODE_EL], [LINK_DEP])
	SELECT DISTINCT 
		[CODE] = RIGHT(LTRIM(RTRIM(E.CODE)),2),
		[SNAME] = LEFT(LTRIM(RTRIM(E.)),50),
		[NAME] = LEFT(LTRIM(RTRIM(E.)),254),
		[CODE_EL] =RIGHT(LTRIM(RTRIM(E.CODE)),2),
		[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()
	FROM
		[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] O ON O.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON O. = B.REF
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] E ON E.REF = B.
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.BUDGET_TYPE A WHERE LTRIM(LTRIM(A.[CODE_EL])) = LTRIM(RTRIM(E.CODE)))

	--   
	--UPDATE D SET D.imns_LINK = I.LINK
	SELECT DISTINCT B_LINK = T.LINK, U_LINK = I.LINK
		INTO #TMP_BU
	FROM
		[{Variable_TempDb}].dbo.[__DEPARTMENTS_] T
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON T.REF = B.REF
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] E ON E.REF = B.

		INNER JOIN (SELECT [LINK], [CODE_EL], NUM = ROW_NUMBER() OVER (PARTITION BY [CODE_EL] ORDER BY [LINK])
						FROM [{Variable_WorkDb}].dbo.BUDGET_TYPE WHERE [CODE_EL] IS NOT NULL
					) I ON I.NUM = 1 AND LTRIM(RTRIM(E.[CODE])) LIKE LTRIM(RTRIM(I.[CODE_EL]))
	WHERE
		I.[LINK] IS NOT NULL
	GO

	DELETE [{Variable_WorkDb}].dbo.BUDGET WHERE EXISTS (SELECT * FROM #TMP_BU WHERE BUDG = B_LINK)
	INSERT INTO [{Variable_WorkDb}].dbo.BUDGET (BUDG, [TYPE]) SELECT B_LINK, U_LINK FROM #TMP_BU
	GO

----
DROP TABLE #ADMBS_LINK

----
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [INSERTED_UIDS]
	END
GO

 	

COMMIT TRAN


