set xact_abort on
BEGIN TRAN

--  
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__MEASURE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__MEASURE_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__MEASURE_]


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].MEASURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--   

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
begin
	INSERT INTO [{Variable_TempDb}].[dbo].[__MEASURE_] (LINK,[Ref]) 
	SELECT 
		P.LINK,
		[Ref]   = convert(uniqueidentifier,d.Ref)
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] d
		INNER JOIN (
			SELECT [LINK], [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
			FROM [{Variable_WorkDb}].dbo.MEASURE
			WHERE LINK_DEP = {LINK_DEP}
		) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[],254)

	--    
	INSERT INTO [{Variable_WorkDb}].dbo.MEASURE (CODE,[SNAME],[NAME],LINK_DEP,[INSERTED_UIDS])
	 OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
	 INTO [{Variable_TempDb}].[dbo].[__MEASURE_]
	SELECT 
		CODE    = isnull(RIGHT(d.Code,5),''),
		SNAME   = d.[Description], 
		NAME    = d.[] , 
		LINK_DEP = {LINK_DEP},
		[INSERTED_UIDS] = d.Ref
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] d
	WHERE 
		NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__MEASURE_] T WHERE T.[Ref] = d.Ref )
	ORDER BY 
		d.Code

end
--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_MEASURE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_MEASURE]

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_MEASURE', ISNULL(@iROWS_NOT_COPIED,0))
--

ALTER TABLE [{Variable_WorkDb}].[dbo].MEASURE DROP COLUMN [INSERTED_UIDS]
GO
COMMIT TRAN

