
set xact_abort on
BEGIN TRAN

--  2.0 CatalogObject|

--   --
USE [{Variable_TempDb}]
GO
----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [Ref] UNIQUEIDENTIFIER NULL
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__NOMENCLATURE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__NOMENCLATURE_] (
    [LINK] int ,
    [Ref] UNIQUEIDENTIFIER )
ELSE 
    DELETE FROM [dbo].[__NOMENCLATURE_]

DECLARE @iROWCOUNT INT
SET @iROWCOUNT = 0
    
--,        
IF (EXISTS (SELECT * 
                 FROM INFORMATION_SCHEMA.TABLES 
                 WHERE TABLE_SCHEMA = 'dbo' 
                 AND  TABLE_NAME = 'CatalogObject|'))
BEGIN

    declare	@obj1 INT, @iERROR INT
    set	@obj1 = [{Variable_WorkDb}].dbo.obj_id('DICT_MONEY_DOCUMENTS')

	
    --      
    DECLARE @iDEFAULT_LINK INT, @iLINK INT

    SELECT @iDEFAULT_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()
 
    SELECT TOP 1
		@iLINK = LINK
	FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
	WHERE ga.CODE_GRP = '20135'
		AND ga.LINK_DEP = @iDEFAULT_LINK

    IF @iLINK IS NULL
	BEGIN
		INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE
			(
			CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED,
			LINK_SELF, CODE_PRF, [OBJECT], LINK_DEP
			)
		SELECT '20135', ' ', NULL,0,2,NULL,1,NULL,NULL,@obj1,@iDEFAULT_LINK

		SELECT TOP 1
			@iLINK = LINK
		FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga
		WHERE ga.CODE_GRP = '20135'
			AND ga.LINK_DEP = @iDEFAULT_LINK
	END

	--   --  
	INSERT INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_] (LINK,[Ref]) 
	SELECT DISTINCT   
			N.LINK, co.[REF]
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] co
		INNER JOIN 
		(	
		SELECT LINK, [NAME],
			NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY [NAME])
		FROM 
			{Variable_WorkDb}.dbo.NOMENCLATURE
		WHERE 
			[LINK_DEP] = {LINK_DEP}
			AND
			[GROUP_INV] = @iLINK
		) N ON N.[NAME] = LEFT(LTRIM(RTRIM( co.[Description])),254)
	WHERE
		N.NUM = 1	
		AND
		LEFT(LTRIM(RTRIM( co.[Description]  )),254) <> ''			


	--   --  ,   
	INSERT INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_] (LINK,[Ref]) 
	SELECT DISTINCT   
			N.LINK, co.[REF]
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] co
		INNER JOIN 
		(	
		SELECT LINK, [CODE],
			NUM = ROW_NUMBER() OVER (PARTITION BY [CODE] ORDER BY [CODE])
		FROM 
			{Variable_WorkDb}.dbo.NOMENCLATURE
		WHERE 
			[LINK_DEP] = {LINK_DEP}
			AND
			[GROUP_INV] = @iLINK
		) N ON N.[CODE] = isnull(RIGHT(co.Code,20),'')
	WHERE
		N.NUM = 1	
		AND	
		isnull(RIGHT(co.Code,20),'') <> ''
		AND
		LEFT(LTRIM(RTRIM( co.[Description]  )),254) = ''
		AND
		NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__NOMENCLATURE_] T WHERE T.[Ref] = co.[REF] )						

	INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
		(CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF, PRICE_TYPE, ISUSED, LINK_DEP,[Ref])
	OUTPUT INSERTED.LINK,INSERTED.[Ref]
		INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_]   
	SELECT
		CODE       = isnull(RIGHT(co.Code,20),''), 
		[NAME]     = LEFT(LTRIM(RTRIM( co.[Description]  )),254),
		GROUP_INV  = @iLINK,
		UM         = m.LINK,
		SERIES     = '',
		IS_EXTRA   = 0,
		LINK_OKDP  = NULL,
		COEFF      = CONVERT(NUMERIC(18,9),1),
		PRICE_TYPE = 0,
		ISUSED     = 1,
		LINK_DEP   = {LINK_DEP},
		Ref        = co.Ref
	FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] co
		LEFT JOIN [{Variable_TempDb}].dbo.__MEASURE_ m ON m.Ref = co.
	WHERE
		NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__NOMENCLATURE_] T WHERE T.[Ref] = co.Ref )			
        
    SET @iROWCOUNT = @@ROWCOUNT
        
	SELECT @iERROR = @@ERROR
	IF @iERROR <> 0
	BEGIN
		ROLLBACK
		RAISERROR('   ',11,1)
	END
    		
END
---
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
---
    
ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [Ref]
GO

COMMIT TRAN

