
set xact_abort ON
BEGIN TRAN
USE [{Variable_TempDb}]
GO
----     
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_CHARACTERISTICS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_CHARACTERISTICS]

GO

CREATE TABLE [dbo].[__JOURNAL_CHARACTERISTICS] (
	[] varchar(max) ,
	[] VARCHAR(MAX) ,
 [] VARCHAR(MAX))
GO
----


--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__CHARACTERISTICS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__CHARACTERISTICS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__CHARACTERISTICS_]
  
----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].CHARACTERISTICS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].CHARACTERISTICS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].CHARACTERISTICS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--   1    
UPDATE T1 SET T1. = T1. + CAST(T2.NUM AS VARCHAR(4))
FROM
	[{Variable_TempDb}].dbo.[|] AS T1
	INNER JOIN 
	(
	SELECT [], , NUM = ROW_NUMBER() OVER (PARTITION BY  ORDER BY [])
	FROM
		[{Variable_TempDb}].dbo.[|]
	) T2 ON T1.[] = T2.[] AND T2.NUM > 1
GO


--   
INSERT INTO [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] (LINK,[Ref]) 
SELECT 
	P.LINK,
	[Ref]   = convert(uniqueidentifier,d.)
FROM 
	[{Variable_TempDb}].dbo.[|] d
	INNER JOIN 
	(
		SELECT 
			LINK, NAME, NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
		FROM
			[{Variable_WorkDb}].dbo.CHARACTERISTICS
		WHERE
			LINK_DEP = {LINK_DEP}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[],100)
WHERE
	ISNULL(LEFT(d.[],100),'') <> ''	
GO

INSERT INTO [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] (LINK,[Ref]) 
SELECT 
	P.LINK,
	[Ref]   = convert(uniqueidentifier,d.)
FROM 
	[{Variable_TempDb}].dbo.[|] d
	INNER JOIN 
	(
		SELECT 
			LINK, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY CODE ORDER BY LINK)
		FROM
			[{Variable_WorkDb}].dbo.CHARACTERISTICS
		WHERE
			LINK_DEP = {LINK_DEP}
	) P ON P.NUM = 1 AND P.[CODE] = LEFT(D.,20)
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] T WHERE T.REF = d.)
	AND
	ISNULL(d.,'') <> ''
GO

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = 0


INSERT INTO [{Variable_WorkDb}].dbo.CHARACTERISTICS
(CODE, NAME, [TYPE], LENGTH, [OBJECT], [SYSTEM], DEF_VAL, LINK_DEP, INSERTED_UIDS)
OUTPUT INSERTED.LINK, INSERTED.INSERTED_UIDS
INTO [{Variable_TempDb}].[dbo].[__CHARACTERISTICS_]
SELECT
	[CODE]      = LEFT(h.[],20), 
	[NAME]      = LEFT(h.[],100), 
	[TYPE]      = 3,-- 3 -  
	[LENGTH]    = convert(numeric(9,4),100), 
	[OBJECT]    = NULL, 
	[SYSTEM]    = 0, 
	DEF_VAL     = NULL, 
	LINK_DEP    = {LINK_DEP},
	INSERTED_UIDS = h.
FROM 
	[{Variable_TempDb}].dbo.[|] h
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] T WHERE T.REF = H.)


SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    --     
    INSERT INTO [{Variable_WorkDb}].dbo.GROUP_CHARS
		(LINK_CHAR, LINK_GROUP, ACTUAL)
    SELECT DISTINCT
		LINK_CHAR   = c.LINK, 
		LINK_GROUP  = i2.GROUP_ACTIVE, 
		ACTUAL      = 0
    FROM 
		[{Variable_TempDb}].dbo.[CatalogObject||] v
		INNER JOIN [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] c ON c.Ref = convert(uniqueidentifier,v.)
		INNER JOIN [{Variable_TempDb}].dbo.__INVENTORY__ i ON convert(uniqueidentifier,v.parent_ref) = i.INSERTED_UIDS
		INNER JOIN [{Variable_WorkDb}].dbo.INVENTORY i2 ON i2.LINK=i.LINK
END

DECLARE @iROWS_NOT_COPIED INT
set @iROWS_NOT_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_CHARACTERISTICS', @iROWS_NOT_COPIED)

ALTER TABLE [{Variable_WorkDb}].[dbo].CHARACTERISTICS DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN
