
set xact_abort on
BEGIN TRAN
USE [{Variable_TempDb}]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[isuniqueidentifier]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[isuniqueidentifier]
GO
create function dbo.IsUniqueidentifier(
@str varchar(100)
)
returns bit
AS
BEGIN
return
CASE WHEN
LEN(@str) = 36
and @str like '____'+replicate('____-',4)+replicate('_',12)
and replace(@str,'-','') not like '%[^0-9A-F]%' THEN 1
ELSE 0 END
END
GO


IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO

--
IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects 
		where id = object_id('[dbo].[CatalogObject||]') 
			and OBJECTPROPERTY(id, N'IsUserTable') = 1)
AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects 
		where id = object_id('[dbo].[|]') 
			and OBJECTPROPERTY(id, N'IsUserTable') = 1)			
AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects 
		where id = object_id('[dbo].[CatalogObject|]') 
			and OBJECTPROPERTY(id, N'IsUserTable') = 1)			

BEGIN

	INSERT INTO #EXEC ([text]) SELECT

    'INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_STRING (LINK_CHAR, LINK_INV, STRING)
		    SELECT
		    LINK_CHAR     = vh.LINK, 
		    LINK_INV      = t.LINK, 
		    --,    - ,      
		    STRING        = case when [{Variable_TempDb}].dbo.ISUNIQUEIDENTIFIER(h.) = 1 THEN 
								(SELECT TOP 1 [Description] FROM [{Variable_TempDb}].dbo.[CatalogObject|] WHERE Ref = convert(uniqueidentifier,h.)) 
								ELSE 
								h. END
		    FROM [{Variable_TempDb}].dbo.[CatalogObject||] h
		    INNER JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] t ON t.INSERTED_UIDS = convert(uniqueidentifier,h.parent_ref)
		    INNER JOIN [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] vh ON vh.Ref = convert(uniqueidentifier,h.)
		
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES ('' "  "'', '' : '' + convert(nvarchar(100),@iROWCOUNT), '''', 0)
    '
    
    enD
    --   CatalogObject|
    else
	IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects 
		where id = object_id('[dbo].[CatalogObject||]') 
			and OBJECTPROPERTY(id, N'IsUserTable') = 1)
AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects 
		where id = object_id('[dbo].[|]') 
			and OBJECTPROPERTY(id, N'IsUserTable') = 1)			

begin
	INSERT INTO #EXEC ([text]) SELECT

    'INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_STRING (LINK_CHAR, LINK_INV, STRING)
		    SELECT
		    LINK_CHAR     = vh.LINK, 
		    LINK_INV      = t.LINK, 
		    STRING        = h.
		    FROM [{Variable_TempDb}].dbo.[CatalogObject||] h
		    INNER JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] t ON t.INSERTED_UIDS = convert(uniqueidentifier,h.parent_ref)
		    INNER JOIN [{Variable_TempDb}].dbo.[__CHARACTERISTICS_] vh ON vh.Ref = convert(uniqueidentifier,h.)
		
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES ('' "  "'', '' : '' + convert(nvarchar(100),@iROWCOUNT), '''', 0)
    '

    
END

	DECLARE @err INT
	IF EXISTS (SELECT * FROM #EXEC)
		EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'
GO

--   . --
--   --
IF OBJECT_ID ('TEMPDB..#INV_CHAR_VALUE') IS NOT NULL
	EXEC ('DROP TABLE #INV_CHAR_VALUE')

CREATE TABLE #INV_CHAR_VALUE
	(
	LINK	INT,
	CODE_CHAR	VARCHAR (20),
	CHAR_VALUE	VARCHAR (1000)
	)

-- 1.     
DECLARE
	@TAB_ID	INT,
	@SQL_EXEC VARCHAR (8000),
	@SQL_EXEC1 VARCHAR (8000),

	@NAME_SMETA	VARCHAR (20),
	@NAME_1C1	VARCHAR (100),
	@NAME_1C2	VARCHAR (100),
	@NAME_1C2_SQL	VARCHAR (100),

	@TABLE_CHECK2	VARCHAR (254)

IF OBJECT_ID ('TEMPDB..#NAME_CHARS') IS NOT NULL
	EXEC ('DROP TABLE #NAME_CHARS')

CREATE TABLE #NAME_CHARS
	(
	LINK	INT IDENTITY (1, 1),
	NAME_SMETA	VARCHAR (20),
	NAME_1C1	VARCHAR (100),
	NAME_1C2	VARCHAR (100),
	TAB_1C1		VARCHAR (100),
	DATA_TYPE	VARCHAR (5),
	DICTION		VARCHAR (30) DEFAULT (''),
	CHAR_LINK	INT DEFAULT (NULL),
	REC_ADDED	TINYINT DEFAULT (0)
	)

SELECT TOP 1
	@TAB_ID = [OBJECT_ID]
FROM [{Variable_TempDb}].[SYS].[TABLES]
WHERE [NAME] = 'InformationRegisterRecordSet|'

IF @TAB_ID IS NOT NULL
BEGIN
	--   --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'CHAR'
	FROM
		(
		--   --
		SELECT NAME_SMETA = 'OS_NUMBER_KADASTR', NAME_1C1 = '', NAME_1C2 = '' UNION ALL
		--    --
		SELECT NAME_SMETA = 'OS_NUMBER_GOS_REG', NAME_1C1 = '', NAME_1C2 = '' UNION ALL
		--    --
		SELECT NAME_SMETA = 'OS_NUMBER_KADASTR_ZU', NAME_1C1 = '', NAME_1C2 = ''
		) AS T1

	--  -  () --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'DATE'
	FROM
		(
		--  --
		SELECT NAME_SMETA = 'OS_DATE_GOS_REG', NAME_1C1 = '', NAME_1C2 = ''
		) AS T1

	--   --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'NUM'
	FROM
		(
		-- [ ] --
		SELECT NAME_SMETA = 'ZEMEL_KADASTR_STOIM', NAME_1C1 = '', NAME_1C2 = '' 
		) AS T1

	SET @SQL_EXEC =
	'
	INSERT INTO #INV_CHAR_VALUE
		(
		LINK,
		CODE_CHAR,
		CHAR_VALUE
		)
	SELECT
		LINK	=	OS.LINK,
		CODE_CHAR = ''{CODE_CHAR}'',
		CHAR_VALUE	= CONVERT (VARCHAR (1000), {NAME_FIELD})
	FROM
		(
		SELECT
			*,
			REC_NO = ROW_NUMBER () OVER (PARTITION BY [] ORDER BY [], [PERIOD] DESC)
		FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|]
		) AS A 
	INNER JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] OS ON
		OS.INSERTED_UIDS = A.[]
		AND A.REC_NO = 1	
	'

	DECLARE #CURSOR1 CURSOR LOCAL STATIC FOR
	SELECT --TOP 5
		NAME_SMETA,
		NAME_1C1,
		NAME_1C2
	FROM #NAME_CHARS
	--WHERE NAME_1C2 = ''

	OPEN #CURSOR1

	FETCH FIRST FROM #CURSOR1
		INTO
			@NAME_SMETA,
			@NAME_1C1,
			@NAME_1C2

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--     --
		IF EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].[SYS].[COLUMNS] A 
					WHERE A.[OBJECT_ID] = @TAB_ID AND A.[NAME] = @NAME_1C2
					)	

		BEGIN
			SET @SQL_EXEC1 = @SQL_EXEC

			SET @NAME_1C2_SQL = 'A.[' + RTRIM (@NAME_1C2) + ']'

			SET @SQL_EXEC1 = REPLACE (@SQL_EXEC1, '{CODE_CHAR}',
									@NAME_SMETA)
				
			SET @SQL_EXEC1 = REPLACE (@SQL_EXEC1, '{NAME_FIELD}',
								@NAME_1C2_SQL)

			EXEC (@SQL_EXEC1)
		END

		FETCH NEXT FROM #CURSOR1
			INTO
				@NAME_SMETA,
				@NAME_1C1,
				@NAME_1C2
	END	

	CLOSE #CURSOR1
	DEALLOCATE #CURSOR1
END

UPDATE #NAME_CHARS
SET REC_ADDED = 1

-- 1.     :

GO

-- 2.    --
DECLARE
	@TAB_ID	INT,
	@SQL_EXEC VARCHAR (8000),
	@SQL_EXEC1 VARCHAR (8000),

	@NAME_SMETA	VARCHAR (20),
	@NAME_1C1	VARCHAR (100),
	@NAME_1C2	VARCHAR (100),
	@NAME_1C2_SQL	VARCHAR (100),

	@TABLE_CHECK2	VARCHAR (254)

SELECT TOP 1
	@TAB_ID = [OBJECT_ID]
FROM [{Variable_TempDb}].[SYS].[TABLES]
WHERE [NAME] = 'InformationRegisterRecordSet|'

IF @TAB_ID IS NOT NULL
BEGIN
	--   (  ) --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'CHAR'
	FROM
		(
		-- VIN --
		SELECT NAME_SMETA = 'VIN_CODE', NAME_1C1 = '', NAME_1C2 = '' UNION ALL
		--  --
		SELECT 'AUTO_MARK', '', '' UNION ALL
		--  --
		SELECT 'AUTO_MODEL', '', '' UNION ALL
		--  --
		SELECT 'AUTO_TYPE', '', '' UNION ALL
		--  --
		SELECT 'ENJIN_MODEL', '', '' UNION ALL
		--  --
		SELECT 'AUTO_NUMBER_MOTOR', '', '' UNION ALL
		--  --
		SELECT 'AUTO_NUMBER_CHASSIS', '', '' UNION ALL
		--  --
		SELECT 'AUTO_NUM_KUZOV', '', '' UNION ALL
		--  --
		SELECT 'AUTO_GARAGE_NUM', '', '' UNION ALL
		--  --
		SELECT 'AUTO_COLUMN', '', '' UNION ALL
		--  --
		SELECT 'AUTO_NUM', '', ''
		) AS T1

	--  -  () --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'DATE'
	FROM
		(
		--  --
		SELECT NAME_SMETA = 'DATE_REG_TC', NAME_1C1 = '', NAME_1C2 = '' UNION ALL
		--  --
		SELECT 'DATE_UNREG_TC', '', '' 
		) AS T1

	--   () --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'NUM'
	FROM
		(
		-- [] --
		SELECT NAME_SMETA = 'AUTO_WEIGHT', NAME_1C1 = '', NAME_1C2 = '' UNION ALL
		-- [] --
		SELECT 'AUTO_TONNAGE', '', ''
		) AS T1

	--   () --
	INSERT INTO #NAME_CHARS 
		(
		NAME_SMETA, NAME_1C1, NAME_1C2,--, TAB_1C1
		DATA_TYPE, DICTION
		)
	SELECT
		T1.NAME_SMETA,
		T1.NAME_1C1,
		T1.NAME_1C2,
		DATA_TYPE = 'DIC',
		DICTION = T1.DICTION
	FROM
		(
		-- [] --
		SELECT NAME_SMETA = 'AUTO_ECO_CLASS', NAME_1C1 = '', NAME_1C2 = '',
			DICTION = 'DICT_ECO_CLASS'
		) AS T1
	
	-- SELECT '#NAME_CHARS', * FROM #NAME_CHARS

	--   --
	SET @TABLE_CHECK2 = 'CatalogObject|'

	SET @SQL_EXEC = 
	'
	INSERT INTO #INV_CHAR_VALUE
		(
		LINK,
		CODE_CHAR,
		CHAR_VALUE
		)
	SELECT
		LINK	=	OS.LINK,
		CODE_CHAR = ''{CODE_CHAR}'',
		CHAR_VALUE	= CONVERT (VARCHAR (1000), {NAME_FIELD})
	FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] A
	INNER JOIN [{Variable_TempDb}].[dbo].[__INVENTORY__] OS ON
		OS.INSERTED_UIDS = A.[]
	'

	DECLARE #CURSOR1 CURSOR LOCAL STATIC FOR
	SELECT --TOP 5
		NAME_SMETA,
		NAME_1C1,
		NAME_1C2
	FROM #NAME_CHARS
	WHERE REC_ADDED = 0

	--WHERE NAME_1C2 = ''

	OPEN #CURSOR1

	FETCH FIRST FROM #CURSOR1
		INTO
			@NAME_SMETA,
			@NAME_1C1,
			@NAME_1C2

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--        --
		IF EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].[SYS].[COLUMNS] A 
					WHERE A.[OBJECT_ID] = @TAB_ID AND A.[NAME] = @NAME_1C2
					)	

		BEGIN
			SET @SQL_EXEC1 = @SQL_EXEC

			SET @NAME_1C2_SQL = 'A.[' + RTRIM (@NAME_1C2) + ']'

			--  CatalogObject| --
			IF	(
				@NAME_SMETA = 'AUTO_MARK'
				OR @NAME_SMETA = 'AUTO_MODEL'
				OR @NAME_SMETA = 'AUTO_TYPE'
				)
				AND 
				EXISTS (SELECT TOP 1 1 FROM [{Variable_TempDb}].[SYS].[TABLES]
							WHERE [NAME] = @TABLE_CHECK2)	
				BEGIN
					SET @SQL_EXEC1 = 
						@SQL_EXEC1
						+ ' LEFT JOIN [{Variable_TempDb}].dbo.['
						+ @TABLE_CHECK2 + '] DOP ON '
						+ 'DOP.Ref = ' + @NAME_1C2_SQL 

					SET @NAME_1C2_SQL = 'ISNULL (DOP.[DESCRIPTION],'''')'
				END
	
			SET @SQL_EXEC1 = REPLACE (@SQL_EXEC1, '{CODE_CHAR}',
									@NAME_SMETA)
				
			SET @SQL_EXEC1 = REPLACE (@SQL_EXEC1, '{NAME_FIELD}',
								@NAME_1C2_SQL)

			EXEC (@SQL_EXEC1)
		END

		FETCH NEXT FROM #CURSOR1
			INTO
				@NAME_SMETA,
				@NAME_1C1,
				@NAME_1C2
	END	

	CLOSE #CURSOR1
	DEALLOCATE #CURSOR1

END	-- IF @TAB_ID IS NOT NULL

UPDATE #NAME_CHARS
SET REC_ADDED = 1

--   : --
GO

--     --
DELETE A
FROM #INV_CHAR_VALUE A 
WHERE ISNULL (A.CHAR_VALUE, '') = ''

--     --
DELETE A
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'DATE'
	AND	(
		A.CODE_CHAR = NC.NAME_SMETA 
		AND ISDATE (A.CHAR_VALUE) = 0
		)

DELETE A
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'NUM'
	AND	(
		A.CODE_CHAR = NC.NAME_SMETA 
		AND ISNUMERIC (A.CHAR_VALUE) = 0
		)

--      --
INSERT INTO [{Variable_WorkDb}].[dbo].[GROUP_CHARS]
	(
	LINK_CHAR, LINK_GROUP, [ACTUAL]
	)
SELECT 
	C.LINK,
	T1.GROUP_ACTIVE,
	0
FROM 
	(
	SELECT
		A.CODE_CHAR,
		INV.GROUP_ACTIVE
	FROM #INV_CHAR_VALUE A
	INNER JOIN [{Variable_WorkDb}].dbo.INVENTORY INV ON INV.LINK = A.LINK
	GROUP BY
		A.CODE_CHAR,
		INV.GROUP_ACTIVE
	) AS T1
INNER JOIN [{Variable_WorkDb}].[dbo].CHARACTERISTICS C ON C.CODE = T1.CODE_CHAR 
LEFT JOIN [{Variable_WorkDb}].[dbo].[GROUP_CHARS] GC ON
	GC.LINK_CHAR = C.LINK
	AND GC.LINK_GROUP = T1.GROUP_ACTIVE
WHERE GC.LINK IS NULL

--   --
INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_STRING
	(
	LINK_INV, LINK_CHAR, [STRING]
	)
SELECT
	A.LINK, C.LINK, A.CHAR_VALUE
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'CHAR'
	AND A.CODE_CHAR = NC.NAME_SMETA 
INNER JOIN [{Variable_WorkDb}].[dbo].CHARACTERISTICS C ON C.CODE = NC.NAME_SMETA
LEFT JOIN [{Variable_WorkDb}].dbo.CHAR_VAL_STRING B ON
	B.LINK_INV = A.LINK
	AND B.LINK_CHAR = C.LINK
WHERE B.LINK_INV IS NULL

--   -  --
INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_DATE
	(
	LINK_INV, LINK_CHAR, [DATE]
	)
SELECT
	A.LINK, C.LINK, CONVERT (DATETIME, A.CHAR_VALUE)
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'DATE'
	AND A.CODE_CHAR = NC.NAME_SMETA 
INNER JOIN [{Variable_WorkDb}].[dbo].CHARACTERISTICS C ON C.CODE = NC.NAME_SMETA
LEFT JOIN [{Variable_WorkDb}].dbo.CHAR_VAL_DATE B ON
	B.LINK_INV = A.LINK
	AND B.LINK_CHAR = C.LINK
WHERE B.LINK_INV IS NULL

--   -  --
INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_NUM
	(
	LINK_INV, LINK_CHAR, [NUMBER]
	)
SELECT
	A.LINK, C.LINK, CONVERT (NUMERIC (18,4), A.CHAR_VALUE)
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'NUM'
	AND A.CODE_CHAR = NC.NAME_SMETA 
INNER JOIN [{Variable_WorkDb}].[dbo].CHARACTERISTICS C ON C.CODE = NC.NAME_SMETA
LEFT JOIN [{Variable_WorkDb}].dbo.CHAR_VAL_DATE B ON
	B.LINK_INV = A.LINK
	AND B.LINK_CHAR = C.LINK
WHERE B.LINK_INV IS NULL

--   -  --
INSERT INTO [{Variable_WorkDb}].dbo.CHAR_VAL_DICTION
	(
	LINK_INV, LINK_CHAR, [DICTION]
	)
SELECT
	A.LINK, C.LINK, D.LINK
FROM #NAME_CHARS NC
INNER JOIN #INV_CHAR_VALUE A ON
	NC.DATA_TYPE = 'DIC'
	AND A.CODE_CHAR = NC.NAME_SMETA 
INNER JOIN [{Variable_WorkDb}].[dbo].CHARACTERISTICS C ON C.CODE = NC.NAME_SMETA
INNER JOIN [{Variable_WorkDb}].[dbo].S_OBJECTS SO ON SO.CODE = NC.DICTION

INNER JOIN [{Variable_WorkDb}].[dbo].DICTION D ON
	SO.CODE = 'DICT_ECO_CLASS'
	AND D.[OBJECT] = SO.LINK
	AND D.CODE = A.CHAR_VALUE

LEFT JOIN [{Variable_WorkDb}].dbo.CHAR_VAL_DICTION B ON
	B.LINK_INV = A.LINK
	AND B.LINK_CHAR = C.LINK
WHERE B.LINK_INV IS NULL

IF OBJECT_ID ('TEMPDB..#INV_CHAR_VALUE') IS NOT NULL
	EXEC ('DROP TABLE #INV_CHAR_VALUE')

IF OBJECT_ID ('TEMPDB..#NAME_CHARS') IS NOT NULL
	EXEC ('DROP TABLE #NAME_CHARS')

GO
	
COMMIT TRAN

