USE {Variable_TempDb}
GO

SET XACT_ABORT ON
BEGIN TRAN


IF not exists(select * from sysobjects where id = object_id('[dbo].[__KL_KBK_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__KL_KBK_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__KL_KBK_]

GO
----   
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_KBK]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_KBK]
---


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].KL_KBK'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--   
IF NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT))
BEGIN

	IF OBJECT_ID('TEMPDB..#DEP','U') IS NOT NULL DROP TABLE #DEP CREATE TABLE #DEP (LINK INT)

	INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS ([CODE], [NAME], [FULL_NAME], [INN], [KPP], [LINK_DEP])
		OUTPUT INSERTED.[LINK] INTO #DEP (LINK)
	SELECT 
		[CODE] = '000',
		[NAME] = '000',
		[FULL_NAME] = '000',
		[INN] = REPLICATE('0',10),
		[KPP] = REPLICATE('0',9),
		[LINK_DEP] = [{Variable_WorkDb}].dbo.getOwnDepLink()

	DECLARE @GROUP_LINK INT SET @GROUP_LINK = (SELECT LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE [SYS] = 10)
   
	INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
	SELECT DISTINCT A.LINK, @GROUP_LINK FROM #DEP A WHERE @GROUP_LINK IS NOT NULL
END
GO

USE {Variable_TempDb}
GO


CREATE TABLE #T0 
(
	[TYPE]			INT
	,[CODE]			VARCHAR(30)
	,[SNAME]		VARCHAR(254)
	,[NAME]			VARCHAR(2000)
	,LINK_ADM		INT
	,DATEB			DATETIME
	,DATEE			DATETIME
	,LINK_DEP		INT
	,[INSERTED_UIDS] UNIQUEIDENTIFIER
	,[Description] VARCHAR(50)
)

--------------
DECLARE @DEF_ADM INT, @DEF_ADM_CODE VARCHAR(10)

SET @DEF_ADM_CODE = 
ISNULL((
SELECT TOP 1 LTRIM(RTRIM(B.Code))
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] T
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] A ON T.Ref = A.Ref
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON B.Ref = A.
ORDER BY
	1	
),'000')	

SET @DEF_ADM = 
(
SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT) WHERE CODE = @DEF_ADM_CODE
)

DECLARE @DEF_ADM000 INT, @DEF_ADM_CODE000 VARCHAR(10)
SELECT TOP 1 @DEF_ADM000 = LINK, @DEF_ADM_CODE000 = CODE FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT) ORDER BY CODE

DECLARE
	@KBK_2016 DATETIME,
	@DATE_FAIL	DATETIME
	
SET @KBK_2016 = '20160101'
SET @DATE_FAIL = '20000101'

IF OBJECT_ID ('TEMPDB..#TempDb_KBK') IS NOT NULL
	EXEC ('DROP TABLE #TempDb_KBK')

SELECT
	*,
	DATE_B1 = CASE
				WHEN ISDATE(kbk.) = 1 THEN CONVERT (DATETIME, [], 127)
				ELSE @DATE_FAIL
			END	
	INTO #TempDb_KBK
FROM [{Variable_TempDb}].dbo.[CatalogObject|] kbk
	

--
IF COLUMNPROPERTY(object_id('[{Variable_TempDb}].[dbo].[CatalogObject|]'), '', 'AllowsNull') is NOT NULL
BEGIN
	UPDATE #TempDb_KBK SET [] = []
	WHERE [] IN ('','','','')
END

--
INSERT INTO #T0
SELECT
	[TYPE] = (CASE WHEN kbk. IN ('','') THEN 1 WHEN kbk. = '' THEN 2 WHEN kbk. = '' THEN 8 END)
	,CODE = 
		ISNULL(AB.CODE,@DEF_ADM_CODE) + '.' + 
				CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.[Code]) = 5 THEN
					(CASE WHEN kbk. IN ('','') THEN SUBSTRING(kbk.[Code],1,4) + '.' + SUBSTRING(kbk.[Code],5,10) + '.' + SUBSTRING(kbk.[Code],15,3) ELSE SUBSTRING(kbk.[Code],1,17) END)														
				ELSE
					(CASE WHEN kbk. IN ('','') THEN SUBSTRING(kbk.[Code],4,4) + '.' + SUBSTRING(kbk.[Code],8,7) + '.' + SUBSTRING(kbk.[Code],15,3) ELSE SUBSTRING(kbk.[Code],4,17) END)
				END
	,SNAME      = ISNULL(LEFT(kbk.Description,254),'')
	,[NAME]     = ISNULL(LEFT(kbk.Description,2000),'')
	,LINK_ADM   = ISNULL(AB.LINK,@DEF_ADM)
	,DATEB      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
	,DATEE      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
	,LINK_DEP   = {LINK_DEP}
	,[INSERTED_UIDS] = kbk.Ref
	,LEFT(kbk.CODE,50)
FROM
	#TempDb_KBK kbk
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] g ON g.Ref = kbk.
	LEFT JOIN (SELECT LINK, CODE, RowNumber = ROW_NUMBER () OVER ( PARTITION BY CODE ORDER BY LINK) FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT) ) AB 
			ON AB.RowNumber = 1 AND AB.CODE = (CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.[Code]) = 5 THEN ISNULL(g.CODE,@DEF_ADM_CODE) ELSE SUBSTRING(kbk.[Code],1,3) END)
WHERE
	kbk. IN ('','','','')
	--------
	UNION 
SELECT
	[TYPE] = T.[TYPE]
	,CODE = 
		ISNULL(AB.CODE,@DEF_ADM_CODE) + '.' + 
			CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.[Code]) = 5 THEN
				(CASE WHEN T.[TYPE] = 1 THEN REPLICATE('0',4) + '.' + REPLICATE('0',10) + '.' + REPLICATE('0',3) ELSE REPLICATE('0',17) END)						
			ELSE
				(CASE WHEN T.[TYPE] = 1 THEN REPLICATE('0',4) + '.' + REPLICATE('0',7) + '.' + REPLICATE('0',3) ELSE REPLICATE('0',14) END)
			END
	,SNAME      = isnull(LEFT(kbk.Description,254),'')
	,[NAME]     = isnull(LEFT(kbk.Description,2000),'')
	,LINK_ADM   = ISNULL(AB.LINK,@DEF_ADM)
	,DATEB      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
	,DATEE      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
	,LINK_DEP   = {LINK_DEP}
	,[INSERTED_UIDS] = kbk.Ref
	,LEFT(kbk.CODE,32) + ' (1_)'
FROM 
	#TempDb_KBK kbk
	INNER JOIN (select [TYPE] = 1 UNION select [TYPE] = 2 UNION select [TYPE] = 4 UNION select [TYPE] = 8) AS T ON 1=1
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] g ON g.Ref = kbk.
	LEFT JOIN (SELECT LINK, CODE, RowNumber = ROW_NUMBER () OVER ( PARTITION BY CODE ORDER BY LINK) FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT) ) AB 
			ON AB.RowNumber = 1 AND AB.CODE = (CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.[Code]) = 5 THEN ISNULL(g.CODE,@DEF_ADM_CODE) ELSE SUBSTRING(kbk.[Code],1,3) END)
WHERE
	kbk. IN ('')
	AND
	SUBSTRING(kbk.[Code],4,20) NOT LIKE '%[1-9]%' 
	UNION	
	SELECT 
		[TYPE] = T.[TYPE]
		,CODE	= 
			ISNULL(AB.CODE,@DEF_ADM_CODE) + '.' + 
				CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.CODE) = 5 THEN
					(CASE WHEN T.[TYPE] = 1 THEN SUBSTRING(kbk.CODE,1,4) + '.' + SUBSTRING(kbk.CODE,5,10) + '.' + SUBSTRING(kbk.CODE,15,3) ELSE SUBSTRING(kbk.CODE,1,17) END)							
				ELSE
					(CASE WHEN T.[TYPE] = 1 THEN SUBSTRING(kbk.CODE,4,4) + '.' + SUBSTRING(kbk.CODE,8,7) + '.' + SUBSTRING(kbk.CODE,15,3) ELSE SUBSTRING(kbk.CODE,4,17) END)
				END
		,SNAME      = isnull(LEFT(kbk.Description,254),'')
		,[NAME]     = isnull(LEFT(kbk.Description,2000),'')
		,LINK_ADM   = ISNULL(AB.LINK,@DEF_ADM)
		,DATEB      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
		,DATEE      = CASE WHEN ISDATE(kbk.) = 1 THEN CONVERT(DATETIME,kbk.) ELSE NULL END
		,LINK_DEP   = {LINK_DEP}
		,[INSERTED_UIDS] = kbk.Ref
		,LEFT(kbk.CODE,32) + ' (1_)'
	FROM
	#TempDb_KBK kbk
	INNER JOIN (select [TYPE] = 1 UNION select [TYPE] = 2 UNION select [TYPE] = 4 UNION select [TYPE] = 8) AS T ON 1=1
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] g ON g.Ref = kbk.
	LEFT JOIN (SELECT LINK, CODE, RowNumber = ROW_NUMBER () OVER ( PARTITION BY CODE ORDER BY LINK) FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT) ) AB 
			ON AB.RowNumber = 1 AND AB.CODE = (CASE WHEN kbk.DATE_B1 >= @KBK_2016 OR patindex('%[-]%',kbk.CODE) = 5 THEN ISNULL(g.CODE,@DEF_ADM_CODE) ELSE SUBSTRING(kbk.CODE,1,3) END)
	WHERE
		kbk. IN ('')
		AND
		SUBSTRING(kbk.CODE,4,20) LIKE '%[1-9]%'
	ORDER BY 
		LEFT(kbk.CODE,50)

---------
--INSERT INTO [{Variable_TempDb}].dbo.[__KL_KBK_]
--SELECT DISTINCT D.LINK, b.INSERTED_UIDS 
--FROM 
--	#T0 b
--	INNER JOIN 
--	(
--		SELECT [LINK], [TYPE], CODE, LINK_ADM, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], CODE, LINK_ADM ORDER BY [LINK])	
--		FROM [{Variable_WorkDb}].dbo.KL_KBK
--		WHERE LINK_DEP = {LINK_DEP}
--	) D	ON D.NUM = 1 AND
--		D.[TYPE] = B.[TYPE] AND D.CODE = B.CODE AND D.LINK_ADM = B.LINK_ADM

--------------

INSERT INTO [{Variable_WorkDb}].dbo.KL_KBK
([TYPE], CODE, SNAME, [NAME], LINK_ADM, DATEB, DATEE,LINK_DEP,[INSERTED_UIDS])
		OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
		INTO [{Variable_TempDb}].dbo.[__KL_KBK_]

SELECT DISTINCT
	[TYPE],
	CODE = LEFT(CODE,24),
	SNAME = LEFT([Description] + ' ' + LTRIM(RTRIM(NAME)), 254),
	[NAME] = LTRIM(RTRIM(NAME)), 
	ISNULL(LINK_ADM,@DEF_ADM),DATEB,DATEE,LINK_DEP,[INSERTED_UIDS]
FROM
	#T0 B
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__KL_KBK_] T WHERE T.Ref = B.[INSERTED_UIDS])
	AND
	(LINK_ADM IS NOT NULL OR @DEF_ADM IS NOT NULL)		
GO

---
DECLARE @iROWCOUNT INT, @iROWS_NOT_COPIED INT, @iERROR INT
set @iROWCOUNT = @@ROWCOUNT

SELECT 
 [] = kbk.Description,
 []       = kbk.,
 []      = CASE WHEN kbk. NOT IN ('','','','') THEN '        : , , , '
                    ELSE '     ' END
INTO [{Variable_TempDb}].dbo.[__JOURNAL_KBK]
FROM #TempDb_KBK kbk
	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] g ON g.Ref = kbk.
WHERE kbk. NOT IN ('','','','')
OR g.Code NOT IN (SELECT CODE FROM [{Variable_WorkDb}].dbo.F_ADMIN_BS(DEFAULT))

SET @iROWS_NOT_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_KBK', @iROWS_NOT_COPIED)
---

ALTER TABLE [{Variable_WorkDb}].[dbo].[KL_KBK] DROP COLUMN [INSERTED_UIDS]
GO

COMMIT TRAN
