USE {Variable_TempDb}
GO

SET XACT_ABORT ON
BEGIN TRAN

---- 
--   

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)	
	AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)		
BEGIN

	INSERT INTO [{Variable_WorkDb}].dbo.KL_TARGET_ITEM
		(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP)
	SELECT CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP
	FROM
	(
	SELECT DISTINCT
		CODE        =

			CASE WHEN LEN(A.CODE) = 23 THEN
				RIGHT(REPLICATE('0',5) + isnull(cs.Code,''),5)
				+ RIGHT(REPLICATE('0',5) + isnull(pcs.Code,''),5) 
			ELSE
				RIGHT(REPLICATE('0',3) + isnull(cs.Code,''),3)
				+ CASE WHEN LEN(pcs.Code) = 4 THEN isnull(pcs.Code,'0000') ELSE isnull(pcs.Code,'00')+isnull(ppcs.Code,'00') END 
			END,		
			
		SNAME       = LEFT(cs.,254),
		[NAME]      = LEFT(cs.,2000),
		DATEB       = CASE WHEN ISDATE(cs.) = 1 THEN CONVERT(datetime,cs.) END,
		DATEE       = CASE WHEN ISDATE(cs.) = 1 THEN CONVERT(datetime,cs.) END,
		LINK_DEP    = {Variable_WorkDb}.dbo.getowndeplink()
	FROM 
		[{Variable_TempDb}].dbo.[__KL_KBK_] sop
		INNER JOIN [{Variable_WorkDb}].dbo.KL_KBK A ON A.[TYPE] = 1 AND A.LINK = sop.LINK
		inner JOIN [{Variable_TempDb}].dbo.[CatalogObject|] kbk ON kbk.Ref = sop.Ref
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cs ON cs.Ref = kbk.
		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] pcs ON pcs.Ref = kbk.
		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] ppcs ON ppcs.Ref = kbk.
	) T	
	WHERE 
		NOT EXISTS (SELECT code FROM [{Variable_WorkDb}].dbo.KL_TARGET_ITEM R WHERE R.CODE = T.CODE)
END	
----

--    
IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	INSERT INTO [{Variable_WorkDb}].dbo.KL_EXPEND
		(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP)
	SELECT DISTINCT
		CODE        = LEFT(pr.Code,3),
		SNAME       = LEFT(pr.,254),
		[NAME]      = LEFT(pr.,2000),
		DATEB       = CASE WHEN ISDATE(pr.) = 1 THEN CONVERT(datetime,pr.) END,
		DATEE       = CASE WHEN ISDATE(pr.) = 1 THEN CONVERT(datetime,pr.) END,
		LINK_DEP    = {Variable_WorkDb}.dbo.getowndeplink()
	FROM 
		[{Variable_TempDb}].dbo.[__KL_KBK_] sop
		INNER JOIN [{Variable_WorkDb}].dbo.KL_KBK A ON A.[TYPE] = 1 AND A.LINK = sop.LINK
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] kbk ON kbk.Ref = sop.Ref
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] pr ON pr.Ref = kbk.
	WHERE 
		(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KL_EXPEND kd WHERE kd.CODE = isnull(pr.Code,'000')) IS NULL 
		AND LEFT(pr.Code,3) NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_EXPEND)

END
		

--   
IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)

BEGIN

	INSERT INTO [{Variable_WorkDb}].dbo.KL_DIVISION
		(CODE, SNAME, NAME, DATEB, DATEE, LINK_DEP)
	SELECT DISTINCT
		CODE        = LEFT(pr.Code,4),
		SNAME       = LEFT(pr.,254),
		[NAME]      = LEFT(pr.,2000),
		DATEB       = NULL,
		DATEE       = NULL,
		LINK_DEP    = {Variable_WorkDb}.dbo.getowndeplink()
	FROM 
		[{Variable_TempDb}].dbo.[__KL_KBK_] sop
		INNER JOIN [{Variable_WorkDb}].dbo.KL_KBK A ON A.[TYPE] = 1 AND A.LINK = sop.LINK
		inner JOIN [{Variable_TempDb}].dbo.[CatalogObject|] kbk ON kbk.Ref = sop.Ref
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] pr ON pr.Ref = kbk.
	WHERE 
		(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KL_DIVISION kd WHERE kd.CODE = isnull(pr.Code,'000')) IS NULL 
		AND LEFT(pr.Code,4) NOT IN (SELECT code FROM [{Variable_WorkDb}].dbo.KL_DIVISION)

END		

--
--IF 
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
--	AND
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
--	AND
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)	
--	AND
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)		
--	AND
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)		
--	AND
--	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)		

--BEGIN


	--INSERT INTO [{Variable_WorkDb}].dbo.KL_VKR(LINK_KBK, Link_DIV, Link_CSR, Link_EXP)
	--SELECT DISTINCT
	--	LINK_KBK    = sop.LINK
	--	,LINK_DIV   = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KL_DIVISION kd WHERE kd.CODE = isnull(pr.Code,'000'))
	--	,LINK_CSR   = 
	--				(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KL_TARGET_ITEM kti WHERE kti.CODE = 
					
	--				CASE WHEN KBK. = '00000000-0000-0000-0000-000000000000' THEN
	--					RIGHT(REPLICATE('0',5) + isnull(cs.Code,''),5)
	--					+ RIGHT(REPLICATE('0',5) + isnull(pcs.Code,''),5) 
	--				ELSE
	--					RIGHT(REPLICATE('0',3) + isnull(cs.Code,''),3)
	--					+ CASE WHEN LEN(pcs.Code) = 4 THEN isnull(pcs.Code,'0000') ELSE isnull(pcs.Code,'00')+isnull(ppcs.Code,'00') END 
	--				END)					
					
	--	,LINK_EXP   = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KL_EXPEND ke WHERE ke.CODE = isnull(vr.Code,'000'))
	--FROM 
	--	[{Variable_TempDb}].dbo.[__KL_KBK_] sop
	--	inner JOIN [{Variable_TempDb}].dbo.[CatalogObject|] kbk ON kbk.Ref = sop.Ref
	--	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] pr ON pr.Ref = kbk.
	--	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cs ON cs.Ref = kbk.
	--	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] pcs ON pcs.Ref = kbk.
	--	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] ppcs ON ppcs.Ref = kbk.
	--	LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] vr ON vr.Ref = kbk.
	--WHERE
	--	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.KL_VKR R WHERE R.[LINK_KBK] = sop.LINK)	

	
----

COMMIT TRAN