-- -
-- 
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO


/*  ,  NUMERIC(19,4)   NVARCHAR(MAX) ( 0,    ) */
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[getNumeric]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION dbo.[getNumeric]

GO

CREATE   FUNCTION dbo.getNumeric(@sVALUE NVARCHAR(MAX))

RETURNS NUMERIC(19,4)
AS
BEGIN
	DECLARE @nRESULT NUMERIC(19,4)
	IF ISNUMERIC(@sVALUE) = 0
	BEGIN
	 SET @nRESULT = 0
	END
	ELSE
	 SET @nRESULT = CONVERT(NUMERIC(19,4),@sVALUE) 
	RETURN @nRESULT
END

GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV___]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV___] (
    [LINK] int ,
    [Ref] UNIQUEIDENTIFIER )
ELSE 
    DELETE FROM [dbo].[__G_PROV___]
GO

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

---
DECLARE @SQL NVARCHAR(4000)
SET @SQL = 'IF OBJECT_ID(''TEMPDB..#NDS'',''U'') IS NOT NULL DROP TABLE #NDS'
EXEC SP_EXECUTESQL @SQL

CREATE TABLE #NDS ([Ref] UNIQUEIDENTIFIER, [] NUMERIC(18,4), [] NUMERIC(18,4), [] NUMERIC(18,4))

IF exists(select 1 from {Variable_TempDb}.dbo.sysobjects where id = object_id('[dbo].[AccumulationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO #NDS ([Ref], [], [], [])
    SELECT 
		kp., 
		[] = 
			CASE WHEN dbo.[getNumeric](kp.) = 0 
				THEN 0
			ELSE
				CASE WHEN ROUND(100 * dbo.[getNumeric]() / (dbo.[getNumeric]()),0) = 18
					THEN 18 ELSE 10
				END
			END,
		dbo.[getNumeric](kp.), 
		dbo.[getNumeric](kp.) 
	FROM {Variable_TempDb}.dbo.[AccumulationRegisterRecordSet|] kp
    WHERE kp.Active = 1
END
-- ,   ,   AccumulationRegisterRecordSet|
IF exists(select 1 from {Variable_TempDb}.dbo.sysobjects where id = object_id('[dbo].[AccumulationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO #NDS ([Ref], [], [], [])
    SELECT 
		kp., 
		[] = 
			CASE WHEN dbo.[getNumeric](kp.) = 0 
				THEN 0
			ELSE
				CASE WHEN ROUND(100 * dbo.[getNumeric]() / (dbo.[getNumeric]()),0) = 18
					THEN 18 ELSE 10
				END
			END,
		dbo.[getNumeric](kp.), 
		dbo.[getNumeric](kp.)
	FROM {Variable_TempDb}.dbo.[AccumulationRegisterRecordSet|] kp
    WHERE kp.Active = 1
END

IF exists(select 1 from {Variable_TempDb}.dbo.sysobjects where id = object_id('dbo.[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO #NDS ([Ref], [], [], [])
    SELECT Recorder, , , 
	FROM
	(
	--      18%
	SELECT
		kp.Recorder,
		 = 18,
		 = dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.),
		 = dbo.[getNumeric](kp.)
	FROM 
		{Variable_TempDb}.dbo.[InformationRegisterRecordSet|] kp
    WHERE 
		kp.Active = 1 and (dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.))<>0
			AND ROUND(100 * dbo.[getNumeric](kp.) / (dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.)),0) = 18
	UNION ALL
	--      18%
	SELECT
		kp.Recorder,
		 = 18,
		 = dbo.[getNumeric](kp.),
		 = dbo.[getNumeric](kp.)
	FROM 
		{Variable_TempDb}.dbo.[InformationRegisterRecordSet|] kp
    WHERE 
		kp.Active = 1  and  (dbo.[getNumeric](kp.) <>0)
			AND ROUND(100 * dbo.[getNumeric](kp.) / (dbo.[getNumeric](kp.)),0) = 18
	UNION ALL
	--      10%
	SELECT
		kp.Recorder,
		 = 10,
		 = dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.),
		 = dbo.[getNumeric](kp.)
	FROM 
		{Variable_TempDb}.dbo.[InformationRegisterRecordSet|] kp
    WHERE 
		kp.Active = 1 and (dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.))<>0
			AND ROUND(100 * dbo.[getNumeric](kp.) / (dbo.[getNumeric](kp.) - dbo.[getNumeric](kp.)),0) = 10
	UNION ALL
	--      10%
	SELECT
		kp.Recorder,
		 = 10,
		 = dbo.[getNumeric](kp.),
		 = dbo.[getNumeric](kp.)
	FROM 
		{Variable_TempDb}.dbo.[InformationRegisterRecordSet|] kp
    WHERE 
		kp.Active = 1 and (dbo.[getNumeric](kp.))<>0
			AND ROUND(100 * dbo.[getNumeric](kp.) / (dbo.[getNumeric](kp.)),0) = 10
	--      10%
	UNION ALL
	SELECT
		kp.Recorder,
		 = 0,
		 = dbo.[getNumeric](kp.),
		 = 0
	FROM 
		{Variable_TempDb}.dbo.[InformationRegisterRecordSet|] kp
    WHERE 
		kp.Active = 1 AND dbo.[getNumeric](kp.) = 0
	)  T
	WHERE NOT EXISTS (SELECT * FROM #NDS N WHERE N.Ref = T.Recorder)
END
GO

-- -
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_ISSUED')

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV___]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = @iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = convert(numeric(28,4),ISNULL(co.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---

    INSERT INTO [{Variable_WorkDb}].dbo.INVOICE_ISSUED WITH (ROWLOCK) (LINK_UP, CONS1_SELF,
                CONS1_LINK, PROD_LINK, CONS2_SELF, CONS2_LINK, PAYS_LINK, NUM_BASE,
                DATE_BASE, BOOK_SALES, OSNOV, TAX_RATE, NALOG_DOC, COR_NUM, COR_DATE,
                TYPE_BOOK, BIL_DATE, AVANSE)
    SELECT 
    LINK_UP         = gp.LINK, 
    CONS1_SELF      = 0,
    CONS1_LINK      = d1.LINK, 
    PROD_LINK       = NULL, 
    CONS2_SELF      = 0, 
    CONS2_LINK      = d2.LINK, 
    PAYS_LINK       = NULL, 
    NUM_BASE        = RIGHT(co.,6),
    DATE_BASE       = CASE WHEN ISDATE(co.) = 1 THEN co. ELSE NULL END, 
    BOOK_SALES      = 1, 
    OSNOV           = dog.LINK, 
    TAX_RATE        = 18, 
    NALOG_DOC       = 0, 
    COR_NUM         = NULL, 
    COR_DATE        = NULL,
    TYPE_BOOK       = NULL, 
    BIL_DATE        = CASE WHEN ISDATE(co.) = 1 THEN co. ELSE NULL END, 
    AVANSE          = 0
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d2 ON d2.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_ dog ON dog.Ref = co.

    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = du.LINK,
    BUYER_LINK      = d1.LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.

    ---   
    DECLARE @iREALIS_OPER INT, @iAVANCE_OPER INT
    SELECT TOP 1 @iREALIS_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_ISSUED_SELLING'
    SELECT TOP 1 @iAVANCE_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_ISSUED_IMPREST'
    
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER
    (LINK_UP, DOC_OPER)
    SELECT
    LINK_UP     = gp.LINK,
    DOC_OPER   = CASE WHEN co. = '' THEN @iREALIS_OPER
                        WHEN co. = '' THEN @iAVANCE_OPER END
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    
    ---  
    DECLARE @iLINK_SF INT, @cSTAVKA VARCHAR(100), @nSUMMA_BEZ_NDS NUMERIC(19,2), @nSUMMA_NDS NUMERIC(19,2), @nSTAVKA_NDS NUMERIC(19,0), @nSUMMA_ALL NUMERIC(19,2), @iNO_NDS INT
    DECLARE CURS CURSOR SCROLL FOR 
		
	SELECT gs.LINK, kp., kp., kp. 
	FROM dbo.[__G_PROV___] gs INNER JOIN #NDS kp on kp.[Ref] = gs.Ref

    OPEN CURS
    FETCH FIRST FROM CURS INTO @iLINK_SF, @nSTAVKA_NDS, @nSUMMA_BEZ_NDS, @nSUMMA_NDS
    WHILE @@FETCH_STATUS=0
    BEGIN
        IF @@FETCH_STATUS=0
        BEGIN
            
            SET @nSUMMA_ALL = @nSUMMA_BEZ_NDS + @nSUMMA_NDS

            SET @iNO_NDS = CASE WHEN @nSTAVKA_NDS <= 1 THEN 1 ELSE 0 END

            SET @iLINK=0
            EXEC [{Variable_WorkDb}].dbo.X_SAVE_DOC_TABLE_MZ_NDS
                @iLINK            
                ,@iLINK_UP          = @iLINK_SF
                ,@iORDERS           = 0
                ,@iINV_TYPE         = NULL
                ,@iINV_LINK         = NULL
                ,@nPRICE            = NULL
                ,@nAKCIZ            = NULL
                ,@iCOUNTRY_LINK     = NULL
                ,@cNUM_TD           = NULL
                ,@nQTY              = NULL
                ,@nSUMMA            = @nSUMMA_BEZ_NDS
                ,@nSTAVKA_NDS       = @nSTAVKA_NDS
                ,@nSUMMA_NDS        = @nSUMMA_NDS
                ,@nSUMMA_ALL        = @nSUMMA_ALL
                ,@iEKR              = NULL
                ,@iFIN_SOURCE       = NULL
                ,@iNO_NDS           = @iNO_NDS
                ,@iTYPE_NDS_LINK    = NULL
                ,@iDOP_CLASSIF_LINK = NULL
                ,@iKAU_LINK         = NULL
                ,@iKL_KBK_LINK      = NULL
                ,@iKL_REG_LINK      = NULL
                ,@nSTAVKA_NDS_AVANSE= 0

            FETCH NEXT FROM CURS INTO @iLINK_SF, @nSTAVKA_NDS, @nSUMMA_BEZ_NDS, @nSUMMA_NDS
        END
    END
    CLOSE CURS
    DEALLOCATE CURS



    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' "- "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN

GO


--   -  ,  
set xact_abort on
BEGIN TRAN

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_ISSUED')

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV___]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = @iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = convert(numeric(28,4),ISNULL(do.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    LEFT JOIN [{Variable_TempDb}].dbo.[DocumentObject|] do ON do.Ref = co.
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---

    INSERT INTO [{Variable_WorkDb}].dbo.INVOICE_ISSUED WITH (ROWLOCK) (LINK_UP, CONS1_SELF,
                CONS1_LINK, PROD_LINK, CONS2_SELF, CONS2_LINK, PAYS_LINK, NUM_BASE,
                DATE_BASE, BOOK_SALES, OSNOV, TAX_RATE, NALOG_DOC, COR_NUM, COR_DATE,
                TYPE_BOOK, BIL_DATE, AVANSE)
    SELECT 
    LINK_UP         = gp.LINK, 
    CONS1_SELF      = 0,
    CONS1_LINK      = NULL,--d1.LINK, 
    PROD_LINK       = NULL, 
    CONS2_SELF      = 0, 
    CONS2_LINK      = NULL,--d2.LINK, 
    PAYS_LINK       = NULL, 
    NUM_BASE        = RIGHT(do.,6),
    DATE_BASE       = CASE WHEN ISDATE(do.) = 1 THEN do. ELSE NULL END, 
    BOOK_SALES      = 1, 
    OSNOV           = dog.LINK, 
    TAX_RATE        = 18, 
    NALOG_DOC       = 0, 
    COR_NUM         = 0,--co., 
    COR_DATE        = NULL,--CASE WHEN ISDATE(co.) = 1 THEN co. ELSE NULL END,
    TYPE_BOOK       = NULL, 
    BIL_DATE        = CASE WHEN (co.='true') THEN co. ELSE NULL END, 
    AVANSE          = 0
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.[DocumentObject|] do ON do.Ref = co.
    --LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.
    --LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d2 ON d2.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_ dog ON dog.Ref = co.

    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = du.LINK,
    BUYER_LINK      = d1.LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' " - "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN

GO


-- 
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV___]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV___] (
    [LINK] int ,
    [Ref] UNIQUEIDENTIFIER )
ELSE 
    DELETE FROM [dbo].[__G_PROV___]
GO

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_RECEIVED')

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV___]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = @iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = convert(numeric(28,4),ISNULL(co.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.INVOICE_ISSUED WITH (ROWLOCK) (LINK_UP, CONS1_SELF,
                CONS1_LINK, PROD_LINK, CONS2_SELF, CONS2_LINK, PAYS_LINK, NUM_BASE,
                DATE_BASE, BOOK_SALES, OSNOV, TAX_RATE, NALOG_DOC, COR_NUM, COR_DATE,
                TYPE_BOOK, BIL_DATE, AVANSE)
    SELECT 
    LINK_UP         = gp.LINK, 
    CONS1_SELF      = 0,
    CONS1_LINK      = NULL, 
    PROD_LINK       = NULL, 
    CONS2_SELF      = 0, 
    CONS2_LINK      = NULL, 
    PAYS_LINK       = NULL, 
    NUM_BASE        = NULL,
    DATE_BASE       = NULL, 
    BOOK_SALES      = 1, 
    OSNOV           = dog.LINK, 
    TAX_RATE        = 18, 
    NALOG_DOC       = 0, 
    COR_NUM         = NULL, 
    COR_DATE        = NULL,
    TYPE_BOOK       = NULL, 
    BIL_DATE        = CASE WHEN ISDATE(co.) = 1 THEN co. ELSE NULL END, 
    AVANSE          = 0
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_ dog ON dog.Ref = co.

    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = d1.LINK,
    BUYER_LINK      = du.LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.
    
    ---   
    DECLARE @iRECEIPT_OPER INT
    SELECT TOP 1 @iRECEIPT_OPER = LINK FROM [{Variable_WorkDb}].dbo.DOC_OPERS do WHERE do.CODE = 'DOC_INVOICE_RECEIVED_RECEIPT'
    
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER
    (LINK_UP, DOC_OPER)
    SELECT
    LINK_UP     = gp.LINK,
    DOC_OPER   = @iRECEIPT_OPER
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref

	--------------
    DECLARE @iLINK_SF INT, @cSTAVKA VARCHAR(100), @nSUMMA_BEZ_NDS NUMERIC(19,2), @nSUMMA_NDS NUMERIC(19,2), @nSTAVKA_NDS NUMERIC(19,0), @nSUMMA_ALL NUMERIC(19,2), @iNO_NDS INT, @LINK2 INT
    DECLARE CURS CURSOR SCROLL FOR 
    SELECT gs.LINK, kp., kp., kp. 
	FROM dbo.[__G_PROV___] gs INNER JOIN #NDS kp on kp.[Ref] = gs.Ref

    OPEN CURS
    FETCH FIRST FROM CURS INTO @iLINK_SF, @nSTAVKA_NDS, @nSUMMA_BEZ_NDS, @nSUMMA_NDS
    WHILE @@FETCH_STATUS=0
    BEGIN
        IF @@FETCH_STATUS=0
        BEGIN
            
            SET @nSUMMA_ALL = @nSUMMA_BEZ_NDS + @nSUMMA_NDS
                
            SET @iNO_NDS = CASE WHEN @nSTAVKA_NDS < 1 THEN 1 ELSE 0 END

            SET @iLINK=0
            EXEC [{Variable_WorkDb}].dbo.X_SAVE_DOC_TABLE_MZ_NDS
                @iLINK	OUTPUT
                ,@iLINK_UP          = @iLINK_SF
                ,@iORDERS           = 0
                ,@iINV_TYPE         = NULL
                ,@iINV_LINK         = NULL
                ,@nPRICE            = NULL
                ,@nAKCIZ            = NULL
                ,@iCOUNTRY_LINK     = NULL
                ,@cNUM_TD           = NULL
                ,@nQTY              = NULL
                ,@nSUMMA            = @nSUMMA_BEZ_NDS
                ,@nSTAVKA_NDS       = @nSTAVKA_NDS
                ,@nSUMMA_NDS        = @nSUMMA_NDS
                ,@nSUMMA_ALL        = @nSUMMA_ALL
                ,@iEKR              = NULL
                ,@iFIN_SOURCE       = NULL
                ,@iNO_NDS           = @iNO_NDS
                ,@iTYPE_NDS_LINK    = NULL
                ,@iDOP_CLASSIF_LINK = NULL
                ,@iKAU_LINK         = NULL
                ,@iKL_KBK_LINK      = NULL
                ,@iKL_REG_LINK      = NULL
                ,@nSTAVKA_NDS_AVANSE= 0

			IF @iLINK > 0
				EXEC [{Variable_WorkDb}].dbo.[X_UPDATE_OUT_TABLE_MZ_INCOME] @LINK2 OUTPUT, @iDOC_LINK = @iLINK_SF, @iLINK_UP = @iLINK

            FETCH NEXT FROM CURS INTO @iLINK_SF, @nSTAVKA_NDS, @nSUMMA_BEZ_NDS, @nSUMMA_NDS
        END
    END
    CLOSE CURS
    DEALLOCATE CURS



    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' "- "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO
COMMIT TRAN

--  
set xact_abort on
BEGIN TRAN

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_RECEIVED')

    ---!!!!!  -  DocumentObject| 
    --     -     ?????
    
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV___]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = 0--@iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = convert(numeric(28,4),ISNULL(do.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    LEFT JOIN [{Variable_TempDb}].dbo.[DocumentObject|] do ON do.Ref = co.
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.<>'' and co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---

    INSERT INTO [{Variable_WorkDb}].dbo.INVOICE_ISSUED WITH (ROWLOCK) (LINK_UP, CONS1_SELF,
                CONS1_LINK, PROD_LINK, CONS2_SELF, CONS2_LINK, PAYS_LINK, NUM_BASE,
                DATE_BASE, BOOK_SALES, OSNOV, TAX_RATE, NALOG_DOC, COR_NUM, COR_DATE,
                TYPE_BOOK, BIL_DATE, AVANSE)
    SELECT 
    LINK_UP         = gp.LINK, 
    CONS1_SELF      = 0,
    CONS1_LINK      = NULL, 
    PROD_LINK       = NULL, 
    CONS2_SELF      = 0, 
    CONS2_LINK      = NULL, 
    PAYS_LINK       = NULL, 
    NUM_BASE        = NULL,
    DATE_BASE       = NULL, 
    BOOK_SALES      = 1, 
    OSNOV           = dog.LINK, 
    TAX_RATE        = 18, 
    NALOG_DOC       = 0, 
    COR_NUM         = 0,--co., 
    COR_DATE        = CASE WHEN ISDATE(co.Date) = 1 THEN co.Date ELSE NULL END,
    TYPE_BOOK       = NULL, 
    BIL_DATE        = CASE WHEN ISDATE(do.) = 1 THEN do. ELSE NULL END, 
    AVANSE          = 0
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.[DocumentObject|] do ON do.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV_ dog ON dog.Ref = co.

    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = d1.LINK,
    BUYER_LINK      = du.LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp ON gp.Ref = co.Ref
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ d1 ON d1.Ref = co.

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' " - "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN


--  
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV____]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV____] (
    [LINK] int ,
    [Ref] UNIQUEIDENTIFIER )
ELSE 
    DELETE FROM [dbo].[__G_PROV____]
GO

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_COR_OUT')

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV____]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = @iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = 0--convert(numeric(28,4),ISNULL(co.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---

    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_INVOICE_COR WITH (ROWLOCK) (DOC_LINK,
                OSNOV, COR_NUM, COR_DATE, INBOOK, TYPE_BOOK, BIL_DATE)
    SELECT 
    DOC_LINK        = gp.LINK,
    OSNOV           = dii.LINK, 
    COR_NUM         = '', 
    COR_DATE        = NULL, 
    INBOOK          = 1, 
    TYPE_BOOK       = 0, 
    BIL_DATE        = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV____ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp2 ON gp2.Ref = case when isnull(co.,'')='' then '00000000-0000-0000-0000-000000000000' else co. end
    LEFT JOIN [{Variable_WorkDb}].dbo.DOC_INVOICE_ISSUED dii ON dii.LINK = gp2.LINK
    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = dii.SEL_LINK,
    BUYER_LINK      = dii.BUY_LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV____ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp2 ON gp2.Ref =  case when isnull(co.,'')='' then '00000000-0000-0000-0000-000000000000' else co. end
    LEFT JOIN [{Variable_WorkDb}].dbo.DOC_INVOICE_ISSUED dii ON dii.LINK = gp2.LINK

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' " - "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN

GO


--  
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV____]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV____] (
    [LINK] int ,
    [Ref] UNIQUEIDENTIFIER )
ELSE 
    DELETE FROM [dbo].[__G_PROV____]
GO

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_INVOICE_COR_OUT')

    ---
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV____]
    SELECT 
    NUMBER          = RIGHT(co.Number,30)
    ,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    ,[OBJECT]       = @iOBJECT
    ,DATE_PROV      = NULL
    ,SUMMA          = 0--convert(numeric(28,4),ISNULL(co.,0))
    ,COMMENT        = LEFT(co.,254)
    ,GET_STORE      = 0
    ,DEP            = du.LINK
    ,ACC            = d.MAIN_LINK
    ,[GUID]         = NULL
    ,Ref            = co.Ref
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---

    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_INVOICE_COR WITH (ROWLOCK) (DOC_LINK,
                OSNOV, COR_NUM, COR_DATE, INBOOK, TYPE_BOOK, BIL_DATE)
    SELECT 
    DOC_LINK        = gp.LINK,
    OSNOV           = dii.LINK, 
    COR_NUM         = '', 
    COR_DATE        = NULL, 
    INBOOK          = 1, 
    TYPE_BOOK       = 0, 
    BIL_DATE        = CASE WHEN isdate(co.[Date]) = 1 THEN convert(datetime,co.[Date]) ELSE NULL END
    
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV____ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp2 ON gp2.Ref =  case when isnull(co.,'')='' then '00000000-0000-0000-0000-000000000000' else co. end
    LEFT JOIN [{Variable_WorkDb}].dbo.DOC_INVOICE_ISSUED dii ON dii.LINK = gp2.LINK
    ---
    DECLARE @iROWCOUNT INT
    set @iROWCOUNT = @@ROWCOUNT

    --- 
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) (LINK_UP, SUPPLIER_LINK,BUYER_LINK)
    SELECT 
    LINK_UP         = gp.LINK, 
    SUPPLIER_LINK   = dii.SEL_LINK,
    BUYER_LINK      = dii.BUY_LINK
    FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
    INNER JOIN [{Variable_TempDb}].dbo.__G_PROV____ gp ON gp.Ref = co.Ref
    LEFT JOIN [{Variable_TempDb}].dbo.__G_PROV___ gp2 ON gp2.Ref = case when isnull(co.,'')='' then '00000000-0000-0000-0000-000000000000' else co. end
    LEFT JOIN [{Variable_WorkDb}].dbo.DOC_INVOICE_ISSUED dii ON dii.LINK = gp2.LINK

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' " - "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN

GO

