--  ,, 
set xact_abort on
BEGIN TRAN
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__G_PROV_]
GO


----   
IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_DOVER]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_DOVER]
---
----    INSERTED_UIDS,     1,         
USE {Variable_WorkDb}
GO

IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]','U'), 'INSERTED_UIDS', 'AllowsNull') is not NULL
	ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] DROP COLUMN [INSERTED_UIDS]
GO
IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]'), 'INSERTED_UIDS', 'AllowsNull') is NULL
   ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

USE {Variable_TempDb}
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO

create table #EXEC (text varchar(8000), id int identity(1,1))
GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	DECLARE @err INT

	INSERT INTO #EXEC ([text]) SELECT
	'
	DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT

	SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id(''DOCUMENTS_ATTORNEY'')

	UPDATE T1
	SET [DATE] = ''20'' + SUBSTRING (T1.[DATE], 3, 30)
	FROM {Variable_TempDb}.dbo.[DocumentObject|] T1
	WHERE LEFT (T1.[DATE], 1) = ''0''

	---
	INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
				DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, INSERTED_UIDS)
	 OUTPUT INSERTED.LINK,INSERTED.[INSERTED_UIDS]
	 INTO [{Variable_TempDb}].dbo.[__G_PROV_]
	 
	SELECT 
	NUMBER          = RIGHT(co.Number,30)
	,DATE           = cast( floor( cast( DATEADD(ss,2,co.date) AS float ) ) AS datetime )
	,[OBJECT]       = @iOBJECT
	,DATE_PROV      = NULL
	,SUMMA          = 0
	,COMMENT        = LEFT(CO.[],254)
	,GET_STORE      = 0
	,DEP            = du.LINK
	,ACC            = NULL
	,[GUID]         = NEWID()
	,INSERTED_UIDS  = co.Ref
	FROM [{Variable_TempDb}].dbo.[DocumentObject|] co
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
	'

	IF EXISTS (SELECT * FROM #EXEC)
		EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

	IF @err <> 0
	BEGIN
		IF @@TRANCOUNT > 0	
		ROLLBACK
	END

	---

	--- 
	INSERT INTO [{Variable_WorkDb}].dbo.ATTORNEY WITH (ROWLOCK) ([LINK_UP], [DATE_ACT], [CONS_SELF], [CONS_LINK], [PAYER_SELF], [EXEC_MARK], [EXEC_BASE], [MOL_LINK], [NUM_BASE], [DATE_BASE], [TYPE])
	SELECT 
		[LINK_UP]		= gp.LINK
		,[DATE_ACT]		= CONVERT(DATETIME,co.,126)-- 
		,[CONS_SELF]	= 1--  
		,[CONS_LINK]	= du.LINK--
		,[PAYER_SELF]	= CONVERT(TINYINT, CASE WHEN co.= 'true' THEN 1 ELSE 0 END)--  
		,[EXEC_MARK]	= 0--   
		,[EXEC_BASE]	= NULL -- (-    )
		,[MOL_LINK]		= TE.LINK--,   
		,[NUM_BASE]		= CASE WHEN DOG.LINK IS NULL THEN NULL ELSE '  ' + ISNULL(LTRIM(RTRIM(G.NUMBER)),'') END --  (  )
		,[DATE_BASE]	= G.[DATE]-- {} ( ,   )
		,[TYPE]			=  1--CASE WHEN CO. = '2' THEN 1 ELSE 2 END --   
	FROM 
		[{Variable_TempDb}].dbo.[DocumentObject|] co
		INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gp ON gp.Ref = co.Ref
		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
		LEFT JOIN [{Variable_TempDb}].dbo.[__G_PROV_] DOG ON DOG.Ref = CO.
		LEFT JOIN [{Variable_WorkDb}].dbo.G_PROV G ON G.LINK = DOG.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[__EMPL_] TE ON TE.Ref = CO.
	WHERE
		co.DeletionMark = 'false'		

	---
	DECLARE @iROWCOUNT INT
	set @iROWCOUNT = @@ROWCOUNT	


	INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_CORR WITH (ROWLOCK) ([LINK_UP], [SUPPLIER_LINK], [BUYER_LINK])
	SELECT 
		[LINK_UP]			= gp.LINK
		,[SUPPLIER_LINK]	= SUP.LINK
		,[BUYER_LINK]		= BUYER.LINK
	FROM 
		[{Variable_TempDb}].dbo.[DocumentObject|] co
		INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gp ON gp.Ref = co.Ref
		LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] SUP on SUP.Ref = co.
		LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] BUYER on BUYER.Ref = co.
	WHERE
		co.DeletionMark = 'false'
			

	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
	---

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
	BEGIN
		IF @@TRANCOUNT > 0
		ROLLBACK
	END
	---

END
GO

USE {Variable_WorkDb}
GO

IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[G_PROV]','U'), 'INSERTED_UIDS', 'AllowsNull') is not NULL
	ALTER TABLE {Variable_WorkDb}.[dbo].[G_PROV] DROP COLUMN [INSERTED_UIDS]
GO

USE {Variable_TempDb}
GO

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	IF COLUMNPROPERTY(object_id('[dbo].[DocumentObject|]','U'), '', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[DocumentObject|] ADD [] NVARCHAR(MAX)
GO


/*  */
IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO

create table #EXEC (text varchar(8000), id int identity(1,1))
GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	IF 
		exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN

		DECLARE @err INT

		INSERT INTO #EXEC ([text]) SELECT
		'
			INSERT INTO [{Variable_WorkDb}].dbo.ATTORNEY_NOMENCLATURE WITH (ROWLOCK) (
				[LINK_UP] --int
				,[LINK_NOM] --int
				,[QTY] --numeric(18, 4) NULL 
				,[NOMEN] --varchar(1000) NULL 
				,[UM_LINK] --int NULL 
			)
			SELECT 
				[LINK_UP] = GP.LINK
				,[LINK_NOM] = NULL
				,[QTY] = T.
				,[NOMEN] = LEFT(T.,4000)
				,[UM_LINK] = TM.LINK
			FROM
				[{Variable_TempDb}].dbo.[__G_PROV_] gp 
				INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] co ON gp.Ref = co.Ref
				INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] T ON T.Parent_Ref = co.Ref
				LEFT JOIN [{Variable_TempDb}].[dbo].[__MEASURE_] TM on TM.Ref = T.
			WHERE
				co.DeletionMark = ''false''
		'

		IF EXISTS (SELECT * FROM #EXEC)
			EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

		IF @err <> 0
		BEGIN
			IF @@TRANCOUNT > 0	
			ROLLBACK
		END

	END

	ELSE
	BEGIN
		
		/*1.   */
		--DROP TABLE #STEP1

		SELECT DISTINCT
			Ref, 
			, 
			REPLACE(,substring(, A.Number, 36 ),REPLICATE('^',36)) as col,
			POS_QUI = A.Number, 
			substring(, A.Number, 36 ) as QUI
		into 
			#STEP1	
		from 
			{Variable_TempDb}.[dbo].[DocumentObject|] CO
			INNER join [master]..spt_values A on substring(, A.Number, 36 ) like '[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]'
									   and A.Number < len() + 1
		where [Type] = 'P' and A.Number > 0

		-----------
		--DROP TABLE #STEP2

		select DISTINCT
			Ref, 
			POS_NUM = A.Number+36,
			, 
			LEN_SUM = 
			LEN(
			CASE 
				WHEN ISNUMERIC(substring(col, A.Number+36, 20 )) = 1 THEN substring(col, A.Number+36, 20)
				WHEN ISNUMERIC(substring(col, A.Number+36, 19 )) = 1 THEN substring(col, A.Number+36, 19)
				WHEN ISNUMERIC(substring(col, A.Number+36, 18 )) = 1 THEN substring(col, A.Number+36, 18)
				WHEN ISNUMERIC(substring(col, A.Number+36, 17 )) = 1 THEN substring(col, A.Number+36, 17)
				WHEN ISNUMERIC(substring(col, A.Number+36, 16 )) = 1 THEN substring(col, A.Number+36, 16)
				WHEN ISNUMERIC(substring(col, A.Number+36, 15 )) = 1 THEN substring(col, A.Number+36, 15)
				WHEN ISNUMERIC(substring(col, A.Number+36, 14 )) = 1 THEN substring(col, A.Number+36, 14)
				WHEN ISNUMERIC(substring(col, A.Number+36, 13 )) = 1 THEN substring(col, A.Number+36, 13)
				WHEN ISNUMERIC(substring(col, A.Number+36, 12 )) = 1 THEN substring(col, A.Number+36, 12)
				WHEN ISNUMERIC(substring(col, A.Number+36, 11 )) = 1 THEN substring(col, A.Number+36, 11)

				WHEN ISNUMERIC(substring(col, A.Number+36, 10 )) = 1 THEN substring(col, A.Number+36, 10)
				WHEN ISNUMERIC(substring(col, A.Number+36, 9 )) = 1 THEN substring(col, A.Number+36, 9)
				WHEN ISNUMERIC(substring(col, A.Number+36, 8 )) = 1 THEN substring(col, A.Number+36, 8)
				WHEN ISNUMERIC(substring(col, A.Number+36, 7 )) = 1 THEN substring(col, A.Number+36, 7)
				WHEN ISNUMERIC(substring(col, A.Number+36, 6 )) = 1 THEN substring(col, A.Number+36, 6)
				WHEN ISNUMERIC(substring(col, A.Number+36, 5 )) = 1 THEN substring(col, A.Number+36, 5)
				WHEN ISNUMERIC(substring(col, A.Number+36, 4 )) = 1 THEN substring(col, A.Number+36, 4)
				WHEN ISNUMERIC(substring(col, A.Number+36, 3 )) = 1 THEN substring(col, A.Number+36, 3)
				WHEN ISNUMERIC(substring(col, A.Number+36, 2 )) = 1 THEN substring(col, A.Number+36, 2)
				WHEN ISNUMERIC(substring(col, A.Number+36, 1 )) = 1 THEN substring(col, A.Number+36, 1)
			END	)
		INTO #STEP2
		from 
			#STEP1 CO
			INNER join [master]..spt_values A on substring(col, A.Number, 36 ) like REPLICATE('^',36)
									   and A.Number < len(col) + 1
		where 
			[Type] = 'P' and A.Number > 0
		ORDER BY
			Ref

		----------------------
		--DROP TABLE #STEP3
		SELECT 
			REF
			,
			,BEG = 
				ISNULL((SELECT NUM1 = MAX(POS_NUM) FROM #STEP2 S2 WHERE S2.REF = S.REF AND S2.POS_NUM < S.POS_NUM),1)
				+ ISNULL((SELECT TOP 1 LEN_SUM FROM #STEP2 S2 WHERE S2.REF = S.REF AND S2.POS_NUM < S.POS_NUM ORDER BY S2.POS_NUM DESC),0)
			,POS_NUM
			,LEN_SUM
		INTO #STEP3	
		FROM
			#STEP2 S
		ORDER BY
			Ref	

		--   
		--DROP TABLE #STEP4
		SELECT 
			REF,
			NOMEN_STR = SUBSTRING(,BEG,POS_NUM + LEN_SUM - BEG)
		INTO 
			#STEP4	
		FROM
			#STEP3
		ORDER BY
			Ref

		----------------------
		--DROP TABLE #STEP5

		SELECT DISTINCT
			Ref, 
			REPLACE(NOMEN_STR,substring(NOMEN_STR, A.Number, 36 ),'^') as col
		INTO 
			#STEP5	
		from 
			#STEP4 CO
			INNER join [master]..spt_values A on substring(NOMEN_STR, A.Number, 36 ) like '[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F]-[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]'
									   and A.Number < len(NOMEN_STR) + 1
		where 
			[type] = 'P' and A.Number > 0

		/*2.  */

		INSERT INTO [{Variable_WorkDb}].dbo.ATTORNEY_NOMENCLATURE WITH (ROWLOCK) ([LINK_UP],[NOMEN],[QTY])
		SELECT 
			D.LINK, LEFT(NOMEN,1000), CNT
		FROM
			#STEP5 T
			INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] D ON D.Ref = T.REF
			cross apply ( select s = col + '^' ) f1
			cross apply ( select p1 = charindex( '^', s ) ) ap1
			cross apply ( select p2 = charindex( '^', s, p1 + 1 ) ) ap2
			cross apply ( select NOMEN = substring( s, 1, p1-1 )                  
								 ,CNT = CONVERT(NUMERIC(18,4),substring( s, p1+1, p2-p1-1 ))
						  ) T2	
		WHERE
			COL NOT LIKE '%^^%' -- ,       , ..    
	END

END
GO


IF @@TRANCOUNT > 0
	COMMIT TRAN
GO

