set xact_abort on
BEGIN TRAN
-- 
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS__] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS__]
GO

USE [{Variable_WorkDb}]
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE {Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].PF_SERVICE_REC'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].PF_SERVICE_REC DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE {Variable_WorkDb}.[dbo].PF_SERVICE_REC ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

USE {Variable_TempDb}
GO

IF exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	--   
	UPDATE D SET D.[TYPE] = 1
	FROM 
		{Variable_TempDb}.dbo.[CatalogObject|] b
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] TK ON TK.Ref = B.
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = TK.LINK
	WHERE b.IsFolder = 'false' AND D.[TYPE] = 0


	--  
	INSERT INTO {Variable_WorkDb}.dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) 
		([CODE],[TYPE],[DEP],[LINK_UP],[ACC],[INSERTED_UIDS]) 
	OUTPUT 
		INSERTED.LINK, INSERTED.[INSERTED_UIDS] 
		INTO {Variable_TempDb}.[dbo].[__DEPARTMENTS__] ([LINK],[Ref])
	SELECT 
		CODE			= RIGHT(b.Code,20), 
		[TYPE]			= 2,
		[DEP]			= TORG.LINK,
		[LINK_UP]		= TK.LINK,
		[ACC]			= NULL,
		[INSERTED_UIDS]	= B.REF
	FROM 
		{Variable_TempDb}.dbo.[CatalogObject|] b
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] TORG ON TORG.Ref = B.
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] TK ON TK.Ref = B.
	WHERE b.IsFolder = 'false'
	ORDER BY B.Code


	--  
	INSERT INTO {Variable_WorkDb}.dbo.PF_SERVICE_REC WITH (ROWLOCK) 
		([COMMENT],[DEP],[DEP_ACC],[INSERTED_UIDS]) 
	OUTPUT 
		INSERTED.LINK, INSERTED.[INSERTED_UIDS] 
		INTO {Variable_TempDb}.[dbo].[__DEPARTMENTS_] ([LINK],[Ref])
	SELECT 
		[COMMENT]		= '  ' + CONVERT(VARCHAR(10),B.[],121),
		[DEP]			= TORG.[LINK],
		[DEP_ACC]		= TDL.[LINK],
		[INSERTED_UIDS]	= B.REF
	FROM 
		{Variable_TempDb}.dbo.[CatalogObject|] b
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS__] TDL ON TDL.Ref = B.REF
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] TORG ON TORG.Ref = B.
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] TK ON TK.Ref = B.
	WHERE b.IsFolder = 'false'
	ORDER BY B.Code


	--    
	DECLARE @LINK_SYS15 INT
	SET @LINK_SYS15 = (SELECT TOP 1 LINK FROM {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS WHERE [SYS] = 15)

	INSERT INTO {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS_REF (GROUP_LINK,DEP_LINK)
	SELECT DISTINCT @LINK_SYS15, DA.[LINK_UP]
	FROM
		{Variable_TempDb}.[dbo].[__DEPARTMENTS_] TD
		INNER JOIN {Variable_WorkDb}.dbo.PF_SERVICE_REC SR ON SR.LINK = TD.LINK
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_ACCOUNTS DA ON DA.LINK = SR.DEP_ACC
	WHERE
		@LINK_SYS15 IS NOT NULL
		AND
		NOT EXISTS (
			SELECT * FROM 
				{Variable_WorkDb}.dbo.DEPARTMENT_GROUPS_REF GR
			WHERE 
				GR.GROUP_LINK = @LINK_SYS15
				AND 
				GR.[DEP_LINK] = DA.[LINK_UP]
		)

END
GO

USE [{Variable_WorkDb}]
GO


----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [INSERTED_UIDS]
	END
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'{Variable_WorkDb}.[dbo].PF_SERVICE_REC'))
	BEGIN
	   ALTER TABLE {Variable_WorkDb}.[dbo].PF_SERVICE_REC DROP COLUMN [INSERTED_UIDS]
	END
GO


COMMIT TRAN

GO



	
	