
/*
  
*/

set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PF_GROUP_SERVICE_REC'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] DROP COLUMN [Ref_]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] ADD [Ref_] UNIQUEIDENTIFIER
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PF_GROUP_SERVICE_REC'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] DROP COLUMN [Ref_]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] ADD [Ref_] UNIQUEIDENTIFIER
GO

IF OBJECT_ID('TEMPDB..#TAB','U') IS NOT NULL
	DROP TABLE #TAB
GO

IF 
	exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	;WITH T AS
	(
	SELECT
		A.,
		A.,
		A.,
		A.,
		[DATE_BEG] = cast( floor( cast( A.Period AS float ) ) AS datetime ),
		 =  case when det.<det. then 'true' else 'false' end
	FROM
		[{Variable_TempDb}].dbo.__DEPARTMENTS_ T
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS DD ON T.LINK = DD.LINK	
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] D ON D.Ref = T.Ref
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] G ON D.Ref = G.[Owner]
		INNER JOIN {Variable_TempDb}.dbo.[InformationRegisterRecordSet|] A ON G.Ref = A.
		-- -  ,   
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] det on det.ref = A.
	--WHERE
	--	DD.INN = '4803004553'	
	) 
	SELECT 
		--LINK_,
		,
		,
		,
		,
		[DATE_BEG],
		[DATE_END] = (SELECT TOP 1 T2.[DATE_BEG] - 1 FROM T AS T2 WHERE T2. = T. AND T2. = T. AND T2.[DATE_BEG] > T.[DATE_BEG] ORDER BY 1),
		
	INTO #TAB
	FROM
		T	
	ORDER BY
		1,2,3
END
GO

--  
IF exists(select * from sysobjects where id = object_id('[dbo].[TMP_KIDS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[TMP_KIDS] 
GO

IF OBJECT_ID('TEMPDB..#TAB','U') IS NOT NULL
BEGIN
	SELECT *,
		NUM1 = ROW_NUMBER() OVER (PARTITION BY A., A. ORDER BY [DATE_BEG]),
		CNT1 = COUNT(*) OVER (PARTITION BY A., A.)
	INTO
		TMP_KIDS
	FROM
		#TAB A
	WHERE
		(DATE_END IS NULL OR DATE_END >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) )
		AND
		 <> 'true'
END
GO

IF COLUMNPROPERTY(object_id('[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|]'), 'Ref_', 'AllowsNull') is NULL
	AND exists(select * from sysobjects where id = object_id('[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    DROP TABLE [dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|]
GO


IF not exists(select * from sysobjects where id = object_id('[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|] (
	[LINK] int ,
	[Ref_] UNIQUEIDENTIFIER,
	[Ref_] UNIQUEIDENTIFIER
	)
ELSE 
	DELETE FROM [dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|]
GO

IF 
	exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[TMP_KIDS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	INSERT INTO [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC]
		(CODE, NAME, AP2, [type], [date_beg], [DEP], Ref_, Ref_)
	OUTPUT 
		INSERTED.LINK, INSERTED.[Ref_], INSERTED.[Ref_]
	INTO 
		[{Variable_TempDb}].[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|] ([LINK],[Ref_],[Ref_])
	SELECT DISTINCT
		CODE = RIGHT(G.Code + CAST(S.NUM AS VARCHAR(10)),10)
		,NAME = LEFT(G.[Description] + ISNULL(' ' + B.[Description],''),254)
		,AP2 = T2.LINK
		,[type] = CASE WHEN B.[Description] LIKE '%%' THEN 1 ELSE 3 END
		,[date_beg] = '20000101'
		,[DEP] = T1.LINK
		,A.[]
		,A.[]
	FROM 
		[{Variable_TempDb}].[dbo].[TMP_KIDS] A
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] G ON G.Ref = A.
		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] T1 ON T1.Ref = G.[Owner]
		INNER JOIN 
		(
		SELECT 
			[],
			[],
			NUM = ROW_NUMBER() OVER (PARTITION BY [] ORDER BY [])
		FROM
			[{Variable_TempDb}].dbo.TMP_KIDS
		GROUP BY
			[], []
		) S ON S.[] = A.[] AND S.[] = A.[]
		INNER JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_] T2 ON T2.Ref = G.[]
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] B ON A.[] = B.Ref
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|] TT WHERE TT.[Ref_] = A.[] AND TT.[Ref_] = A.[])
END
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_LINK]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [INSERTED_LINK] INT NULL
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__NOMENCLATURE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__NOMENCLATURE_] (
	[LINK] int ,
	[LINK_GR] int )
--ELSE 
--	DELETE FROM [dbo].[__NOMENCLATURE_]
GO

----
DECLARE @iOBJECT INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'NOMENCLATURE_SERVICE'

--    
DECLARE @iLINK21 INT
SET @iLINK21 = [{Variable_WorkDb}].dbo.[getOwnDepLink]()

--      
DECLARE @iLINK INT
SELECT TOP 1 @iLINK = LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '90000' AND ga.[OBJECT] = @iOBJECT AND CODE_PRF IS NULL

IF 
	exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[TMP_KIDS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
		(CODE, [NAME], GROUP_INV, IS_EXTRA, COEFF, PRICE_TYPE, ISUSED, LINK_DEP, [INSERTED_LINK])
	OUTPUT INSERTED.LINK, INSERTED.[INSERTED_LINK]
		INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_] (LINK, LINK_GR)	
	SELECT 
		CODE        = '' + ISNULL(RIGHT(GR.CODE,18),''),
		[NAME]      = LEFT(GR.NAME,254), 
		GROUP_INV   = @iLINK, --
		IS_EXTRA    = 0, 
		COEFF       = CONVERT(NUMERIC(18,9),1), 
		PRICE_TYPE  = 0, 
		ISUSED      = 1,
		LINK_DEP    = {LINK_DEP},
		INSERTED_LINK = GR.LINK
	FROM
		[{Variable_TempDb}].dbo.__DEPARTMENTS_ T
		INNER JOIN [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] GR ON GR.DEP = T.[LINK]
		INNER JOIN [{Variable_TempDb}].[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|] T2 on T2.LINK = GR.LINK
	WHERE
		EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.TMP_KIDS TK WHERE TK. = T2.Ref_ AND TK. = T2.Ref_)
		AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__NOMENCLATURE_] WHERE LINK_GR = GR.LINK)
END
GO

--    
UPDATE G SET G.NOMEN = T.LINK
FROM
	[{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] G
	INNER JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_] T ON G.LINK = T.LINK_GR
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_LINK]
GO

--   
IF 
	exists(select * from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[TMP_KIDS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO {Variable_WorkDb}.[dbo].[PF_SERVICE_REC_GROUP] ([LINK_UP],[DATE_BEG],[DATE_END],[GROUP],[RATIO],[AP1])
	SELECT 
		[LINK_UP] = F.LINK, --
		[DATE_BEG] = ISNULL(A.[DATE_BEG],'20050101'), -- 
		[DATE_END] = A.[DATE_END],
		[GROUP] = D.LINK, --
		[RATIO] = 1,
		[AP1] = H.LINK --
	FROM
		[{Variable_TempDb}].[dbo].[TMP_KIDS] A
		INNER JOIN {Variable_TempDb}.[dbo].[__PF_GROUP_SERVICE_REC_SPLIT_CatalogObject|] C ON A.[] = C.[REF_] AND A.[] = C.[REF_]
		INNER JOIN {Variable_WorkDb}.[dbo].[PF_GROUP_SERVICE_REC] D ON D.LINK = C.LINK
		INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_] E ON E.Ref = A.
		INNER JOIN {Variable_WorkDb}.[dbo].[PF_SERVICE_REC] F ON F.LINK = E.LINK
		LEFT JOIN {Variable_TempDb}.[dbo].[__G_PROV_] G ON G.Ref = A.
		LEFT JOIN {Variable_WorkDb}.[dbo].[G_PROV] H ON H.LINK = G.LINK
	WHERE
		NOT EXISTS (SELECT * FROM {Variable_WorkDb}.[dbo].[PF_SERVICE_REC_GROUP] I WHERE I.[LINK_UP] = F.[LINK] AND I.[GROUP] = D.LINK)
END
GO


use {Variable_WorkDb}
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DOP_CLASSIF'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[DOP_CLASSIF] DROP COLUMN [Ref]
	END
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PF_GROUP_SERVICE_REC'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] DROP COLUMN [Ref_]
	END
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PF_GROUP_SERVICE_REC'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] DROP COLUMN [Ref_]
	END
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_LINK' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [INSERTED_LINK]
	END
GO

COMMIT TRAN

GO
