
USE {Variable_TempDb}
GO

SET XACT_ABORT ON

BEGIN TRAN
GO


IF NOT Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'DEP' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PI_MOUTH'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].[PI_MOUTH] ADD [DEP] INT
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PI_MOUTH'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PI_MOUTH] DROP COLUMN [Ref_]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[PI_MOUTH] ADD [Ref_] UNIQUEIDENTIFIER
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__PI_MOUTHF_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__PI_MOUTHF_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__PI_MOUTHF_]
GO


IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
create table #EXEC (text varchar(8000), id int identity(1,1))
GO


DECLARE @err INT

IF exists(
	select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('dbo.[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1
	)
BEGIN

	DELETE FROM #EXEC

	INSERT INTO #EXEC ([text]) SELECT
	'
	--   
	INSERT INTO [{Variable_TempDb}].dbo.[__PI_MOUTHF_] (LINK,[Ref]) 
	SELECT 
		P.LINK,
		[Ref]   = convert(uniqueidentifier,co.Ref)
	FROM 
		[{Variable_TempDb}].dbo.__DEPARTMENTS_ T
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON T.Ref = co.[Owner]
		INNER JOIN (
			SELECT LINK, [DEP], [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY [DEP], [NAME] ORDER BY [NAME])
			FROM [{Variable_WorkDb}].[dbo].[PI_MOUTH] P 
			WHERE LEN(NAME) > 0
		) P ON P.NUM = 1 AND T.LINK = P.[DEP] AND P.[NAME] = LEFT(co.[Description],254)
	WHERE
		co.IsFolder = ''false''
	'

	INSERT INTO #EXEC ([text]) SELECT
	'
	DECLARE @iROWCOUNT INT

	INSERT INTO [{Variable_WorkDb}].dbo.PI_MOUTH
	(CODE, NAME, IS_PERS, [DEP], Ref_)
			 OUTPUT INSERTED.LINK, INSERTED.[Ref_]
			 INTO [{Variable_TempDb}].dbo.[__PI_MOUTHF_]
	SELECT
		CODE	= LEFT(co.[Code],10)
		,NAME	= LEFT(co.[Description],250)
		,IS_PERS = (CASE WHEN CO.[] = ''false'' THEN 0 ELSE 1 END)
		,[DEP]	= T.LINK
		,Ref_     = co.Ref
	FROM 
		[{Variable_TempDb}].dbo.__DEPARTMENTS_ T
		INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] co ON T.Ref = co.[Owner]
	WHERE
		co.IsFolder = ''false''	 
		AND
		NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__PI_MOUTHF_] T WHERE T.Ref =co.Ref )

	--    
	SET @iROWCOUNT = @@ROWCOUNT

	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES ('' " "'', '' : '' + convert(nvarchar(100),@iROWCOUNT), '''',0)'
	
	--    - ,    
	IF exists(
	select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('dbo.[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1
	)
	INSERT INTO #EXEC ([text]) SELECT'
	INSERT INTO [{Variable_WorkDb}].dbo.PI_MOUTH_HIST_COST (LINK_UP, ONE_COST, [DATE])
	SELECT 
		LINK_UP = T.LINK 
		,ONE_COST = CO.
		,[DATE] = cast( floor( cast( CO.Period AS float ) ) AS datetime )
	FROM
		[{Variable_WorkDb}].dbo.PI_MOUTH T
		INNER JOIN [InformationRegisterRecordSet|] CO ON CO.[] = T.Ref_
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.PI_MOUTH_HIST_COST A WHERE A.LINK_UP = T.LINK AND A.[DATE] = cast( floor( cast( CO.Period AS float ) ) AS datetime ))

	'
	IF EXISTS (SELECT * FROM #EXEC)
		EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

END

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'Ref_' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[PI_MOUTH]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PI_MOUTH] DROP COLUMN [Ref_]
	END
GO

GO

COMMIT TRAN

GO
