
-- -  
set xact_abort on
BEGIN TRAN

--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_] (
    [LINK] int,
    [Ref] UNIQUEIDENTIFIER)
ELSE 
    DELETE FROM [dbo].[__G_PROV_]
GO


IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO

----    Ref,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
    BEGIN
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
    END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [Ref] UNIQUEIDENTIFIER NULL
GO

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	and exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[AccumulationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
    DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT, @iROWCOUNT INT

    SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_MENU_DEM_REST')
    INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) (NUMBER, DATE, [OBJECT],
                DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, GUID, Ref)
     OUTPUT INSERTED.LINK,INSERTED.[Ref]
     INTO [{Variable_TempDb}].dbo.[__G_PROV_]
    SELECT 
		NUMBER          = RIGHT(co.Number,30)
		,DATE           = CASE WHEN isdate(co.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,co.[Date])), 0) ELSE NULL END
		,[OBJECT]       = @iOBJECT
		,DATE_PROV      = NULL
		,SUMMA          = 0
		,COMMENT        = LEFT(co.,254)
		,GET_STORE      = 0
		,DEP            = du.LINK
		,ACC            = d.MAIN_LINK
		,[GUID]         = NULL
		,Ref            = co.Ref
		FROM 
			[{Variable_TempDb}].[dbo].[DocumentObject|] co
			INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] du on du.Ref = co.
			LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON D.LINK = du.LINK
    WHERE 
		co.[Date] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --  
		AND
		NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_] R WHERE R.REF = co.Ref) 

    SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    ---  - .
	INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_EMPL WITH (ROWLOCK) ([DOC_LINK], [OBJECT], [EMPL])
    SELECT 
		[DOC_LINK]  = gp.LINK, 
		[OBJECT] = @iOBJECT,
		[EMPL] = E.LINK
    FROM 
		[{Variable_TempDb}].[dbo].[DocumentObject|] co
		INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gp ON gp.Ref = co.Ref
		LEFT JOIN [{Variable_TempDb}].[dbo].[CatalogObject|] CMO ON CMO.REF = CO.
		LEFT JOIN [{Variable_TempDb}].[dbo].[__EMPL_] E ON E.REF = CMO.
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_EMPL R WHERE R.[DOC_LINK] = gp.LINK AND R.[EMPL] = E.LINK)
	ORDER BY
		gp.LINK, E.LINK

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

	--  
	INSERT INTO [{Variable_WorkDb}].dbo.DOC_MENU_DEM_REST_GROUP	(LINK_UP,[GROUP],MOUTH_COUNT)
	SELECT
		[LINK_UP] = T1.LINK 
		,[GROUP] = A.LINK
		,[MOUTH_COUNT] = ST.
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T1
		INNER JOIN [{Variable_TempDb}].[dbo].[DocumentObject|] T ON T.REF = T1.REF
		INNER JOIN  [{Variable_TempDb}].[dbo].[DocumentObject||] ST ON ST.parent_ref = T.REF
		--	( SELECT DISTINCT RECORDER, ,  FROM [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] 
		--	) ST ON ST.RECORDER = T.REF
		INNER JOIN [{Variable_TempDb}].[dbo].[__PI_MOUTHF_] A ON A.REF = ST. 
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DOC_MENU_DEM_REST_GROUP R WHERE R.[LINK_UP] = T1.LINK AND R.[GROUP] = A.LINK)
	ORDER BY
		T.REF, A.LINK

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

	DECLARE @iTABLE_OBJ_ID INT
	SET @iTABLE_OBJ_ID = [{Variable_WorkDb}].dbo.[obj_id]('DOC_MENU_DEM_REST_MZ_GRID2')

	-- 
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_OPER],[COMMENT],[LINK_OLD])
	SELECT
		[LINK_UP] = T1.LINK
		,[OBJECT] = @iTABLE_OBJ_ID
		,[ORDERS] = ROW_NUMBER() OVER (PARTITION BY T1.LINK ORDER BY RP.LINK)  
		,[LINK_OPER] = NULL
		,[COMMENT] = NULL
		,[LINK_OLD] = RP.LINK
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T1
		INNER JOIN [{Variable_TempDb}].[dbo].[DocumentObject|] T ON T.REF = T1.REF
		INNER JOIN [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] RP ON RP.RECORDER = T.REF
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] Z WHERE Z.[LINK_UP] = T1.LINK)

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

	--    
	INSERT [{Variable_WorkDb}].dbo.[DOC_MENU_DEM_REST_ROW] ([LINK_TABLE_ROW], [LINK_GROUP_ROW])
	SELECT
		[LINK_TABLE_ROW] = OT.LINK
		,[LINK_GROUP_ROW] = B.LINK
	FROM
		[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT
		INNER JOIN [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] RP ON OT.[LINK_OLD] = RP.LINK
		INNER JOIN [{Variable_TempDb}].[dbo].[__PI_MOUTHF_] A ON A.REF = RP.
		INNER JOIN [{Variable_WorkDb}].dbo.DOC_MENU_DEM_REST_GROUP B ON B.LINK_UP = OT.LINK_UP AND B.[GROUP] = A.LINK
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[DOC_MENU_DEM_REST_ROW] Z WHERE Z.[LINK_TABLE_ROW] = OT.LINK AND Z.[LINK_GROUP_ROW] = B.LINK)

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

	--
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] ([LINK_UP],[INV_TYPE],[NOMEN_LINK])
	SELECT
		[LINK_UP] = OT.[LINK]
		,[INV_TYPE] = 2
		,[NOMEN_LINK] = NN.LINK
	FROM
		[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT
		INNER JOIN [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] RP ON OT.[LINK_OLD] = RP.LINK
		INNER JOIN [{Variable_TempDb}].[dbo].[__NOMENCLATURE_] N ON N.REF = RP.[]
		INNER JOIN [{Variable_WorkDb}].[dbo].[NOMENCLATURE] NN ON NN.LINK = N.[LINK]
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] Z WHERE Z.[LINK_UP] = OT.[LINK])

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

	--,   
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_MZ_SUMMA] ([LINK_ROW],[QTY],[QTY_M],[SUMMA],[PRICE])
	SELECT
		[LINK_UP] = OT.[LINK]
		,[QTY] = RP.[] 
		,[QTY_M] = RP.[] 
		,[SUMMA] = RP.[]
		,[PRICE] = 0 --(CASE WHEN ISNULL(RP.[],0) > 0 THEN CONVERT(numeric(19, 4),(RP.[] / RP.[])) ELSE 0 END)
	FROM
		[{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT
		INNER JOIN [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] RP ON OT.[LINK_OLD] = RP.LINK
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_MZ_SUMMA] Z WHERE Z.[LINK_ROW] = OT.[LINK])

	UPDATE S SET
		[PRICE] = (CASE WHEN S.[QTY] > 0 THEN S .[SUMMA] / S.[QTY] ELSE 0 END)
	FROM
		[{Variable_WorkDb}].dbo.[OUT_TABLE_MZ_SUMMA] S
		INNER JOIN [{Variable_WorkDb}].[dbo].[OUT_TABLE_ROW] OT ON S.[LINK_ROW] = OT.[LINK]
		INNER JOIN [{Variable_TempDb}].[dbo].[AccumulationRegisterRecordSet|] RP ON OT.[LINK_OLD] = RP.LINK

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' "-  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    ---

    SELECT @iError = @@ERROR
    IF @iError <> 0
    BEGIN
        ROLLBACK
    END
    ---
END

GO

IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'Ref' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
       ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [Ref]
GO

COMMIT TRAN

GO


