set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__SUBDIV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__SUBDIV_] (
	[LINK_UP] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__SUBDIV_]

GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[CatalogObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	
	;WITH TreeCTE(Code, [Description], depth, Parent, [Ref])
	AS
	(
	  -- anchor member
	  SELECT cast('' as nvarchar(max)) as Code , 
	   cast('Trees'  as nvarchar(max)) as [Description], 
	   cast('0' as Integer) as depth, 
	   cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier) as Parent, 
	   cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier) as [Ref]

	  UNION ALL

	  -- recursive member
	  SELECT s.Code, 
	   s.[Description], 
	   cte.depth+1, 
	   isnull(convert(uniqueidentifier,s.Parent), cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier)), 
	   isnull(s.[Ref], cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier)) 
	  FROM 
		[{Variable_TempDb}].dbo.[CatalogObject|] S 
		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dp on dp.Ref = S.[Owner]		
		JOIN TreeCTE AS cte
		  ON isnull(convert(uniqueidentifier,s.Parent), cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier)) = isnull( cte.[Ref] , cast('00000000-0000-0000-0000-000000000000' as uniqueidentifier))
	  WHERE S.DeletionMark = 'false'
	)
	--     
	SELECT
	s.[Ref]  , s.Code, s.[Description], s.depth, s.Parent   
	INTO #recur
	FROM TreeCTE s
	WHERE s.depth > 0


	DECLARE @iDepth INT, @iLINK_UP INT
	SET @iDepth = 1
	WHILE EXISTS (SELECT 1 FROM #recur WHERE depth = @iDepth)
	BEGIN

			
	DECLARE @CODE VARCHAR(5), @NAME VARCHAR(254), @UID UNIQUEIDENTIFIER, @ParentUID UNIQUEIDENTIFIER, @iLINK_SELF INT
	SET @iLINK_SELF = NULL

	DECLARE @iLINK_DEP INT

	DECLARE the_cursor CURSOR FAST_FORWARD
	FOR SELECT RIGHT (Code,5), [Description], [Ref], Parent
	FROM #recur WHERE depth = @iDepth

	OPEN the_cursor
	FETCH NEXT FROM the_cursor INTO @CODE, @NAME, @UID, @ParentUID

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--    ,   depth = 1
		SET @iLINK_UP = 0

		SELECT
			@iLINK_DEP = dp.LINK
		FROM [{Variable_TempDb}].dbo.[CatalogObject|] p
		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dp on dp.Ref = p.[Owner] 
		WHERE p.Ref = @UID

		INSERT INTO [{Variable_WorkDb}].dbo.SUBDIV_HEAD
			(
			DEP_LINK, [GUID], LINK_INS, CODE, [NAME], LINK_SELF 
			)
		SELECT
			@iLINK_DEP, NULL, NULL, @CODE, isnull(@NAME,''), NULL 
		
		SET @iLINK_UP = SCOPE_IDENTITY()
		
		SELECT @iLINK_SELF = LINK_UP FROM [{Variable_TempDb}].dbo.[__SUBDIV_] WHERE Ref = @ParentUID
			
		INSERT INTO [{Variable_WorkDb}].dbo.[SUBDIV]
			(
			LINK_UP, CODE, [NAME], LINK_SELF, ORDERS, DATE_BEGIN, DATE_END
			)
		VALUES (@iLINK_UP, @CODE, isnull(@NAME,''), @iLINK_SELF, 0, DATEADD(yy, DATEDIFF(yy,0,getdate()), 0), '2099-01-01 00:00:00.000')
	  
		INSERT INTO [{Variable_TempDb}].dbo.[__SUBDIV_]
			(
			LINK_UP, Ref
			)
		VALUES (@iLINK_UP, @UID)

		FETCH NEXT FROM the_cursor INTO @CODE, @NAME, @UID, @ParentUID
	END

	CLOSE the_cursor
	DEALLOCATE the_cursor
			SET @iDepth = @iDepth + 1
	END

	DROP TABLE #recur

	--    
	IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_SUBDIV]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_SUBDIV]

	SELECT
		 = s.Code, 
		 = s.[Description],
		 = '  '
			INTO [{Variable_TempDb}].dbo.[__JOURNAL_SUBDIV]
	FROM [{Variable_TempDb}].dbo.[CatalogObject|] S
	WHERE S.DeletionMark = 'true'
	  
	DECLARE @iROWCOUNT INT, @iROWS_NOT_COPIED BIGINT
	SET @iROWS_NOT_COPIED = @@ROWCOUNT
	SELECT @iROWCOUNT = COUNT(1) 
	FROM [{Variable_TempDb}].dbo.[__SUBDIV_]
	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_SUBDIV', isnull(@iROWS_NOT_COPIED,0))

	--
	EXECUTE [{Variable_WorkDb}].[dbo].[XA_ADJUST_SUBDIV]

END

COMMIT TRAN