set xact_abort on
BEGIN TRAN

USE [{Variable_TempDb}]

GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__CONTACT_INFO_ADD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__CONTACT_INFO_ADD]
		(
		[LINK] INT
		)
ELSE
BEGIN
	DELETE B 
	FROM [dbo].[__CONTACT_INFO_ADD] A
	INNER JOIN [{Variable_WorkDb}].dbo.CONTACT_INFO B ON B.LINK = A.LINK
		
	DELETE FROM [dbo].[__CONTACT_INFO_ADD]
END
GO

IF OBJECT_ID ('TEMPDB..#DEP_REF') IS NOT NULL
	EXEC ('DROP TABLE #DEP_REF')

CREATE TABLE #DEP_REF
	(
	LINK	INT,
	REF	UNIQUEIDENTIFIER
	)
GO

DECLARE
	@SQL_EXEC	VARCHAR (1000)

SET @SQL_EXEC = ''

--    --
IF exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	SET @SQL_EXEC = 'SELECT A.[LINK], A.[Ref] FROM [dbo].[__DEPARTMENTS_] A '

--     --
IF exists(select * from sysobjects where id = object_id('[dbo].[__PERSON_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	SET @SQL_EXEC = 
		CASE
			WHEN @SQL_EXEC <> '' THEN @SQL_EXEC + ' UNION '
			ELSE ''
		END
		+ 'SELECT A.[LINK], A.[Ref] FROM [dbo].[__PERSON_] A '

--    --
IF exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	SET @SQL_EXEC = 
		CASE
			WHEN @SQL_EXEC <> '' THEN @SQL_EXEC + ' UNION '
			ELSE ''
		END
		+ 'SELECT A.[LINK], A.[Ref] FROM [dbo].[__DEPARTMENTS_] A '

IF @SQL_EXEC <> ''
BEGIN
	SET @SQL_EXEC = 'INSERT INTO #DEP_REF ([LINK], [Ref]) ' + @SQL_EXEC
	EXEC (@SQL_EXEC)
END

--SELECT '#DEP_REF', * FROM #DEP_REF

IF 
	exists(select 1 from dbo.sysobjects where id = object_id('[dbo].[CatalogObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN 
	DECLARE @T_CONTACT_TYPE TABLE
		(
		REF	UNIQUEIDENTIFIER,
		LINK	INT
		)

	INSERT INTO @T_CONTACT_TYPE
		(
		REF,
		LINK
		)
	SELECT
		A.REF,
		CT.LINK
	FROM dbo.[CatalogObject|] A
	INNER JOIN [{Variable_WorkDb}].dbo.CONTACT_TYPE CT ON
		A.[] = ''
		AND
		(
			(
			A.[PredefinedDataName] = ''
				OR A.[PredefinedDataName] = ''
				OR A.[PredefinedDataName] = ''
				OR [PredefinedDataName] = ''
			)
				AND CT.[CODE] = ''
			OR
			(
			A.[PredefinedDataName] = ''
				OR A.[PredefinedDataName] = ''
				OR A.[PredefinedDataName] = ''
			)
				AND CT.[CODE] = ''
		)
		OR
		A.[] = '' AND CT.[CODE] = ''
		OR 
		A.[] = '' AND CT.[CODE] = ''
		OR
		A.[] = '' AND CT.[CODE] = 'MAIL'

	INSERT INTO [{Variable_WorkDb}].dbo.CONTACT_INFO
		(
		DEPARTMENT, CONTACT_TYPE, CONTACT
		)
	OUTPUT INSERTED.LINK
		INTO [dbo].[__CONTACT_INFO_ADD]
	SELECT
		DR.LINK,
		A_TYPE.LINK,
		A.[]
	FROM @T_CONTACT_TYPE A_TYPE
	INNER JOIN [dbo].[CatalogObject||] A ON
		A.[] = A_TYPE.REF
	INNER JOIN #DEP_REF DR ON DR.REF = A.[PARENT_REF] 

END

GO

IF OBJECT_ID ('TEMPDB..#DEP_REF') IS NOT NULL
	EXEC ('DROP TABLE #DEP_REF')

COMMIT TRAN

GO

