set xact_abort on
BEGIN TRAN

---  ---
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__EMPL_]
		(
		[LINK] int ,
		[Ref] UNIQUEIDENTIFIER
		)
ELSE 
	DELETE FROM [dbo].[__EMPL_]
	
GO

----    INSERTED_UIDS,     1,         
IF Exists(select 1 from [{Variable_WorkDb}].sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[EMPL]'))
	ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] DROP COLUMN [INSERTED_UIDS]
GO

ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO

--  ,    
INSERT INTO [{Variable_WorkDb}].[dbo].[EMPL]
	(
	[PERS_LINK],
	[TAB],
	[DEP_LINK],
	[PHONE_S],
	[PHONE_M],
	[EMAIL],
	FIO,
	[INSERTED_UIDS]
	)
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__EMPL_]
SELECT 
	PC.LINK,
	TAB         = RIGHT(S.Code,10),
	DEP_LINK    = dp.LINK,--LINK_DEP
	PHONE_S     = '',
	PHONE_M     = '',
	EMAIL       = '',
	FIO         = s.[Description],
	[INSERTED_UIDS] = S.Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] S 
	INNER JOIN [{Variable_TempDb}].dbo.__PERSON_ PC ON PC.Ref = S.
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dp on dp.Ref = s.[Owner]
ORDER BY 
	PC.LINK

-- - --
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

--  ,     
INSERT INTO [{Variable_WorkDb}].[dbo].[EMPL]
	(
	[PERS_LINK],
	[TAB],
	[DEP_LINK],
	[PHONE_S],
	[PHONE_M],
	[EMAIL],
	FIO,
	[INSERTED_UIDS]
	)
OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__EMPL_]
SELECT 
	PC.LINK,
	TAB         = RIGHT(s.Code,10),
	DEP_LINK    = dp.LINK,
	PHONE_S     = '',
	PHONE_M     = '',
	EMAIL       = '',
	FIO         = s.[Description],
	[INSERTED_UIDS] = s.Ref
FROM 
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] PC
	INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] S ON
		S.REF = PC.REF
		AND S.IsFolder = 'false'
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] dp on dp.Ref = s.[Owner]
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__EMPL_] T WHERE T.REF = s.Ref)
ORDER BY 
	PC.LINK

SET @iROWCOUNT = @iROWCOUNT + @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] DROP COLUMN [INSERTED_UIDS]
GO

IF 
	exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[InformationRegisterRecordSet|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	---  
	INSERT INTO [{Variable_WorkDb}].[dbo].[EMPL_POST]
			   ([LINK_UP]
			   ,[POST_LINK]
			   ,[SUBDIV_LINK]
			   ,[DATE_BEG]
			   ,[DATE_END])
	SELECT
		LINK_UP     = ES.LINK,
		POST_LINK   = PD.LINK,
		SUBDIV_LINK = S.LINK,
		DATE_BEG    = case when isdate(ds.Period) = 1 then convert(datetime,ds.Period) ELSE '' END,
		DATE_END    = NULL
	FROM 
		[{Variable_TempDb}].[dbo].[InformationRegisterRecordSet|] ds
		INNER JOIN [{Variable_TempDb}].[dbo].__EMPL_ ES ON ES.[Ref] = ds.
		INNER JOIN [{Variable_TempDb}].[dbo].__SUBDIV_ SP ON SP.[Ref] = ds.
		INNER JOIN [{Variable_WorkDb}].dbo.SUBDIV_HEAD s ON s.link = sp.link_up
		INNER JOIN [{Variable_TempDb}].[dbo].__EMPL_POST_ PD ON PD.[Ref] = ds.
END
GO


EXECUTE [{Variable_WorkDb}].[dbo].[XA_ADJUST_EMPL_POST]
GO

COMMIT TRAN