set xact_abort on
BEGIN TRAN


USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_GROUPS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__EMPL_GROUPS_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__EMPL_GROUPS_]

GO

---    INSERTED_UIDS,     1,         
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'INSERTED_UIDS' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].EMPL_GROUPS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS DROP COLUMN [INSERTED_UIDS]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS ADD [INSERTED_UIDS] UNIQUEIDENTIFIER NULL
GO



INSERT INTO [{Variable_TempDb}].dbo.[__EMPL_GROUPS_] ([LINK],[Ref])
SELECT 
	G.[LINK],
	T.[Ref]
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] T
	INNER JOIN [{Variable_WorkDb}].[dbo].EMPL_GROUPS G ON G.LINK_DEP = {LINK_DEP} AND G.[NAME] = isnull(LEFT([Description],60),'')
WHERE 
	IsFolder = 'true' AND DeletionMark = 'false'
GO


INSERT INTO [{Variable_WorkDb}].[dbo].EMPL_GROUPS
(SNAME, [NAME], SYS, LINK_DEP, [INSERTED_UIDS])
    OUTPUT INSERTED.LINK, INSERTED.[INSERTED_UIDS]
    INTO [{Variable_TempDb}].dbo.[__EMPL_GROUPS_]
SELECT 
	SNAME   = isnull(LEFT([Description],10),''),
	[NAME]  = isnull(LEFT([Description],60),''),
	[SYS]     = 0,
	LINK_DEP = {LINK_DEP},
	[INSERTED_UIDS] = Ref
FROM 
	[{Variable_TempDb}].dbo.[CatalogObject|] T
WHERE 
	IsFolder = 'true' AND DeletionMark = 'false'
	AND
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].[dbo].EMPL_GROUPS G WHERE G.LINK_DEP = {LINK_DEP} AND G.[NAME] = isnull(LEFT(T.[Description],60),'') )

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

IF exists(select 1 from [{Variable_TempDb}].dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_EMPL_GROUP]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [{Variable_TempDb}].dbo.[__JOURNAL_EMPL_GROUP]

SELECT
   = isnull(LEFT([Description],10),''),
 = '  '
INTO [{Variable_TempDb}].dbo.[__JOURNAL_EMPL_GROUP]
FROM [{Variable_TempDb}].dbo.[CatalogObject|]
WHERE IsFolder = 'true' AND DeletionMark = 'true'
ORDER BY 

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_EMPL_GROUP', isnull(@iROWS_NOT_COPIED,0))
--
ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS DROP COLUMN [INSERTED_UIDS]
GO

------    
INSERT INTO [{Variable_WorkDb}].dbo.EMPL_GROUPS_REF
(EMPL_LINK, GROUP_LINK)
SELECT
e.LINK, eg.LINK
FROM [{Variable_TempDb}].dbo.[CatalogObject|] p
INNER JOIN [{Variable_TempDb}].dbo.[CatalogObject|] child ON child.Parent = p.Ref
INNER JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON e.Ref = child.
INNER JOIN [{Variable_TempDb}].dbo.[__EMPL_GROUPS_] eg ON eg.Ref = p.Ref
WHERE p.IsFolder = 'true' AND p.DeletionMark = 'false' AND child.DeletionMark = 'false'

COMMIT TRAN
