set xact_abort on
BEGIN TRAN

--   --
IF OBJECT_ID ('TEMPDB..#DEP_FACES') IS NOT NULL
	EXEC ('DROP TABLE #DEP_FACES')

CREATE TABLE #DEP_FACES
	(
	FACE	UNIQUEIDENTIFIER,
	DEP_REF	UNIQUEIDENTIFIER,
	TYPE_FACE	VARCHAR (1000),
	PERIOD	DATETIME
	)

IF EXISTS (
			select 1 from [{Variable_TempDb}].dbo.sysobjects
						where id = object_id('[dbo].[InformationRegisterRecordSet|]')
							and OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
	EXEC (
		'INSERT INTO #DEP_FACES (FACE, DEP_REF, TYPE_FACE, PERIOD)'
		+ ' SELECT [],[],[],Period'
		+ ' FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] '
		)	
GO

USE {Variable_TempDb}
GO

----   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_FACES
(LINK_UP, [TYPE], EMPL, PERSON, DEP, PHONE, POST, [USED])
SELECT 
	LINK_UP     = d.LINK,
	[TYPE]      = dft.LINK,
	EMPL        = e.LINK,
	PERSON      = NULL,
	DEP         = NULL,
	PHONE       = '',
	POST        = dft.NAME,
	USED        = 1
FROM [{Variable_TempDb}].dbo.__DEPARTMENTS_ d
CROSS APPLY (SELECT TOP 1 TTT.FACE FROM #DEP_FACES TTT WHERE TTT.DEP_REF = d.Ref AND TTT.TYPE_FACE = '' ORDER BY TTT.Period DESC) glb
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_FACES_TYPE dft ON dft.CODE = ''
LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON e.Ref = glb.FACE	
UNION ALL
SELECT 
	LINK_UP     = d.LINK,
	[TYPE]      = dft.LINK,
	EMPL        = e.LINK,
	PERSON      = NULL,
	DEP         = NULL,
	PHONE       = '',
	POST        = dft.NAME,
	USED        = 1
FROM [{Variable_TempDb}].dbo.__DEPARTMENTS_ d
CROSS APPLY (SELECT TOP 1 TTT.FACE FROM #DEP_FACES TTT WHERE TTT.DEP_REF = d.Ref AND TTT.TYPE_FACE = '' ORDER BY TTT.Period DESC) kas
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_FACES_TYPE dft ON dft.CODE = ''
LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON e.Ref = kas.FACE	
UNION ALL
SELECT 
	LINK_UP     = d.LINK,
	[TYPE]      = dft.LINK,
	EMPL        = e.LINK,
	PERSON      = NULL,
	DEP         = NULL,
	PHONE       = '',
	POST        = dft.NAME,
	USED        = 1
FROM [{Variable_TempDb}].dbo.__DEPARTMENTS_ d
CROSS APPLY (SELECT TOP 1 TTT.FACE FROM #DEP_FACES TTT WHERE TTT.DEP_REF = d.Ref AND TTT.TYPE_FACE = '' ORDER BY TTT.Period DESC) ruk
INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_FACES_TYPE dft ON dft.CODE = ''
LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ e ON e.Ref = ruk.FACE	

COMMIT TRAN


IF OBJECT_ID ('TEMPDB..#DEP_FACES') IS NOT NULL
	EXEC ('DROP TABLE #DEP_FACES')
GO


