USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_ A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


set xact_abort ON
BEGIN TRAN

USE {Variable_TempDb}

IF OBJECT_ID('TEMPDB..#EXEC','U') IS NOT NULL
	DROP TABLE #EXEC
GO
	
CREATE TABLE #EXEC (text varchar(8000), id int identity(1,1))
GO

INSERT INTO #EXEC ([text]) SELECT
'
--    1 
--    :    1         
DECLARE @dSTART_DATE DATETIME, @dEND_DATE DATETIME, @dFIRST_DAY_OF_YEAR DATETIME, @dDATE_REST DATETIME
SET @dFIRST_DAY_OF_YEAR = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   --''20170101''--
--    ,    
SET @dSTART_DATE = ''20090101''
SET @dEND_DATE = DATEADD(SECOND, -1, @dFIRST_DAY_OF_YEAR)

SET @dDATE_REST = cast( floor( cast( @dEND_DATE AS float ) ) AS datetime )
'

INSERT INTO #EXEC ([text]) SELECT
' 
INSERT INTO [{Variable_WorkDb}].dbo.SALDO
    (DATE, ACCOUNT, D_SUMMA, K_SUMMA, R_SUMMA, D_QUANTITY, K_QUANTITY, ISOBOROT,
    KBK, EKR, DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC, TMC, INDATE, SGU, AP1, AP2,
    AP3, AP4, AP5, AP6, DEP_LINK, PRICE)
SELECT
	[DATE]       = @dDATE_REST,
	ACCOUNT    = ar.ACCOUNT,
	D_SUMMA    = SUM (D_SUMMA),
	K_SUMMA    = SUM (K_SUMMA), 
	R_SUMMA    = SUM (R_SUMMA), 
	D_QTY = SUM (D_QTY),
	K_QTY = SUM (K_QTY),
	ISOBOROT   = 2,
 
    KBK        = ar.KBK, 
    EKR        = ar.EKR, 
    DEP        = ar.DEP, 
    SUB        = ar.SUB, 
    EMP        = ar.EMP, 
    NOMEN      = ar.NOMEN, 
    INV        = ar.INV,
    KAU        = ar.KAU,
    DEP_ACC    = ar.DEP_ACC, 
    TMC        = ar.TMC, 
    INDATE     = NULL, 
    SGU        = ar.SGU_REST, 
    AP1        = ar.AP1, 
    AP2        = ar.AP2,
    AP3        = NULL, 
    AP4        = NULL, 
    AP5        = NULL, 
    AP6        = NULL, 
    DEP_LINK   = AR.DEP_LINK, 
    PRICE      = 0
'

INSERT INTO #EXEC ([text]) SELECT
' 
FROM 
	(
	SELECT
		SA.CODE,
		GAP.*,
		SGU_REST = CASE WHEN SA.p_Kassa = 1 THEN GAP.SGU ELSE NULL END,

		D_SUMMA	=	CASE
						WHEN GAP.DB_KR = 0 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 0 THEN G2.SUMMA
						WHEN GAP.DB_KR = 1 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 0 THEN -G2.SUMMA
						ELSE 0
					END,
		K_SUMMA	=	CASE
						WHEN GAP.DB_KR = 0 AND SA.S_ACTIVE = 0 AND SA.S_PASSIVE = 1 THEN -G2.SUMMA
						WHEN GAP.DB_KR = 1 AND SA.S_ACTIVE = 0 AND SA.S_PASSIVE = 1 THEN G2.SUMMA
						ELSE 0
					END,
		R_SUMMA	=	CASE
						WHEN GAP.DB_KR = 0 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 1 THEN G2.SUMMA
						WHEN GAP.DB_KR = 1 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 1 THEN -G2.SUMMA
						ELSE 0
					END,
		D_QTY	=	CASE
						WHEN GAP.DB_KR = 0 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 0 THEN G2.QTY
						WHEN GAP.DB_KR = 1 AND SA.S_ACTIVE = 1 AND SA.S_PASSIVE = 0 THEN -G2.QTY
						ELSE 0
					END,
		K_QTY	=	CASE
						WHEN GAP.DB_KR = 0 AND SA.S_ACTIVE = 0 AND SA.S_PASSIVE = 1 THEN -G2.QTY
						WHEN GAP.DB_KR = 1 AND SA.S_ACTIVE = 0 AND SA.S_PASSIVE = 1 THEN G2.QTY
						ELSE 0
					END,
		DEP_LINK = G.DEP_LINK 
	FROM [{Variable_TempDb}].[dbo].[__PROV_HDR_1C] G
	INNER JOIN [{Variable_TempDb}].[dbo].[__PROV_ANALIT_1C] GAP ON GAP.LINK_UP = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON SA.LINK = GAP.ACCOUNT
	WHERE G.[DATE] BETWEEN @dSTART_DATE AND @dEND_DATE
	) AS ar
GROUP BY
	ar.DEP_LINK,
	ar.ACCOUNT, ar.KBK,
    ar.EKR, ar.DEP, ar.SUB, ar.EMP, ar.NOMEN, ar.INV, ar.KAU, ar.DEP_ACC, ar.SGU_REST,
	ar.TMC, ar.AP1, ar.AP2
HAVING
	SUM (ar.D_SUMMA) <> 0
	OR SUM(ar.K_SUMMA) <> 0
	OR SUM(ar.R_SUMMA) <> 0
	OR SUM(ar.D_QTY) <> 0
	OR SUM(ar.K_QTY) <> 0
'

INSERT INTO #EXEC ([text]) SELECT
'
--     SALDO_HEADER,        
INSERT INTO [{Variable_WorkDb}].dbo.SALDO_HEADER 
(DEP_LINK, ACCOUNT, DATE)
SELECT s.DEP_LINK, s.ACCOUNT, s.DATE
FROM [{Variable_WorkDb}].dbo.SALDO s
WHERE s.ISOBOROT = 2
AND NOT EXISTS (SELECT 1 FROM [{Variable_WorkDb}].dbo.SALDO_HEADER sh WHERE sh.DEP_LINK = s.DEP_LINK AND sh.ACCOUNT = s.ACCOUNT AND sh.DATE = s.DATE)
GROUP BY s.DEP_LINK, s.ACCOUNT, s.DATE
'

DECLARE @err INT
EXEC @err = dbo.ssp_execresultset 'select text from #EXEC order by id'

COMMIT TRAN

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO
