USE {Variable_TempDb}
GO

-- -  
set xact_abort on
BEGIN TRAN

--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_] (
    [LINK] int,
	[REF] UNIQUEIDENTIFIER)
ELSE 
    DELETE FROM [dbo].[__G_PROV_]
GO

IF Exists(select 1 from [{Variable_TempDb}].sys.columns where Name = N'ROW_ID' and Object_ID = Object_ID(N'[{Variable_TempDb}].[dbo].[DocumentObject||]'))
    BEGIN
       ALTER TABLE [{Variable_TempDb}].[dbo].[DocumentObject||] DROP COLUMN ROW_ID
    END
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__] (
	code varchar(1),
	name varchar(250) )
ELSE 
	DELETE FROM [dbo].[__]

GO

insert into __
select '1',''
union all
select '2',''
union all
select '4',''
union all
select '3',''
union all
select '5',''
union all
select '6',''
union all
select '7',''

go


IF exists(select * from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	ALTER TABLE [{Variable_TempDb}].[dbo].[DocumentObject||] ADD ROW_ID INT IDENTITY(1,1)
GO

DECLARE @iLINK INT, @iError INT, @iOBJECT INT, @iACC INT, @iROWCOUNT INT
SELECT @iOBJECT = [{Variable_WorkDb}].dbo.obj_id('DOC_BSO_PEREMESH')

IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.G_PROV WITH (ROWLOCK) 
		([NUMBER], [DATE], [OBJECT], [DATE_PROV], [SUMMA], [COMMENT], [GET_STORE], [DEP], [ACC], [GUID])
	OUTPUT INSERTED.LINK, INSERTED.[GUID]
		INTO [{Variable_TempDb}].dbo.[__G_PROV_] (LINK, [REF])
	SELECT 
		NUMBER          = RIGHT(AR.Number,30)
		,[DATE]          = CASE WHEN isdate(AR.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,AR.[Date])), 0) ELSE NULL END
		,[OBJECT]       = @iOBJECT
		,DATE_PROV      = NULL
		,SUMMA          = 0
		,COMMENT        = LEFT(AR.,254)
		,GET_STORE      = 0
		,DEP            = DEP.LINK
		,ACC            = DEP.MAIN_LINK
		,[GUID]         = AR.[REF]
	FROM
		[{Variable_TempDb}].dbo.[DocumentObject|] AR
		INNER JOIN [{Variable_TempDb}].[dbo].[__DEPARTMENTS_] do on do.Ref = AR.
		INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS DEP ON DEP.LINK = do.LINK
	WHERE
		(CASE WHEN isdate(AR.[Date]) = 1 THEN DATEADD(DAY, DATEDIFF(DAY, 0, convert(datetime,AR.[Date])), 0) ELSE NULL END) >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)
		AND AR.DeletionMark = 'false' 
		AND NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__G_PROV_] R WHERE R.[REF] = AR.[REF]) 

	SELECT @iError = @@ERROR, @iROWCOUNT = @@ROWCOUNT
	IF @iError <> 0
		ROLLBACK

	INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
	VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
END
GO


---  - , 
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.DOC_BSO_MOLS WITH (ROWLOCK) ([LINK_UP], [MOL1], [MOL2])
	SELECT 
		[LINK_UP] = T.LINK
		,[MOL1] = EMP1.LINK
		,[MOL2] = EMP2.LINK
	FROM 
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF

		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cmo1 ON cmo1.Ref = AR. 
		LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ es1 ON es1.Ref = convert(uniqueidentifier,cmo1.)
		LEFT JOIN {Variable_WorkDb}.dbo.EMPL EMP1 ON EMP1.LINK = ES1.LINK

		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] cmo2 ON cmo2.Ref = AR. 
		LEFT JOIN [{Variable_TempDb}].dbo.__EMPL_ es2 ON es2.Ref = convert(uniqueidentifier,cmo2.)
		LEFT JOIN {Variable_WorkDb}.dbo.EMPL EMP2 ON EMP2.LINK = ES2.LINK
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DOC_BSO_MOLS R WHERE R.[LINK_UP] = T.LINK)
	ORDER BY
		T.LINK

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO

-- 
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER(LINK_UP,DOC_OPER)
	SELECT 
		[LINK_UP] = T.LINK
		,[DOC_OPER] = D_OP.LINK
	FROM 
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN {Variable_WorkDb}.dbo.DOC_OPERS D_OP ON D_OP.CODE = 'MOVING'
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_DOC_OPER R WHERE R.[LINK_UP] = T.LINK)
	ORDER BY
		T.LINK

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO

IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DECLARE @iTABLE_OBJ_ID INT
	SET @iTABLE_OBJ_ID = [{Variable_WorkDb}].dbo.[obj_id]('DOC_BSO_NAKLAD_TABLE')

	-- 
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_INS])
	SELECT
		[LINK_UP] = T.LINK
		,[OBJECT] = @iTABLE_OBJ_ID
		,[ORDERS] = ROW_NUMBER() OVER (PARTITION BY T.LINK ORDER BY T.LINK, AR1.[])  
		,[LINK_INS] = AR1.ROW_ID
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] AR1 ON AR.Ref = AR1.Parent_Ref
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_ROW] Z WHERE Z.[LINK_UP] = T.LINK)

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO


--
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] (LINK_UP, INV_TYPE, NOMEN_LINK)
	SELECT
		LINK_UP = OT.LINK
		,INV_TYPE = 3
		,NOMEN_LINK = N.LINK
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] AR1 ON AR.Ref = AR1.Parent_Ref
		INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[LINK_INS] = AR1.[ROW_ID]
		LEFT JOIN [{Variable_TempDb}].dbo.__NOMENCLATURE_ BSO ON AR1. = BSO.REF
		LEFT JOIN {Variable_WorkDb}.dbo.NOMENCLATURE N ON BSO.LINK = N.LINK
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_TYPE] Z WHERE Z.LINK_UP = OT.LINK)

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO

--
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_SUM_ACCT] ([LINK_UP], [BALANCE], [QTY], [PRICE], [ACCOUNT_B])
	SELECT
		LINK_UP = OT.LINK
		,[BALANCE] = ([{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., AR1.)) - [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0)) + 1)
		,[QTY] = ([{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., AR1.)) - [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0)) + 1)
		,[PRICE] = 1
		,[ACCOUNT_B] = sa1.LINK
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] AR1 ON AR.Ref = AR1.Parent_Ref
		INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[LINK_INS] = AR1.[ROW_ID]
		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = AR.
		left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
		LEFT JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS_1C sa1 ON sa1.CODE = (k.code + '.' + accCD.Code) AND sa1.LINK_DEP = VD.LINK_CB
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_INV_SUM_ACCT] Z WHERE Z.[LINK_UP] = OT.LINK)

	UPDATE SA SET SA.ap_TMC = 1
	FROM {Variable_WorkDb}.dbo.S_ACCOUNTS SA
	WHERE 
		SA.ap_TMC = 0
		AND
		EXISTS (
			SELECT * FROM
				[{Variable_TempDb}].dbo.[__G_PROV_] T
				INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
				INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
				INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
				INNER JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = AR.
				left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
				INNER JOIN {Variable_WorkDb}.dbo.S_ACCOUNTS_1C sa1 ON sa1.CODE = (k.code + '.' + accCD.Code) AND sa1.LINK_DEP = VD.LINK_CB
			WHERE
				SA.LINK = SA1.LINK
		)

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO

--
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT [{Variable_WorkDb}].dbo.[OUT_TABLE_ANALIT] ([LINK_ROW], [KAU], [PRICE], [FIN_SOURCE])
	SELECT
		[LINK_ROW] = OT.LINK
		,[KAU] = KAU.LINK
		,[PRICE] = 1
		,[FIN_SOURCE] = FS.LINK
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] AR1 ON AR.Ref = AR1.Parent_Ref
		INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[LINK_INS] = AR1.[ROW_ID]

		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = AR.
		left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
		LEFT JOIN {Variable_WorkDb}.dbo.FIN_SOURCE FS ON k.code = FS.CODE

		--LEFT JOIN dbo.__KAU_ TB ON TB.REF = AR.
		LEFT JOIN [{Variable_TempDb}].dbo.__KAU_ TB ON TB.Ref = AR.
		LEFT JOIN [{Variable_TempDb}].dbo.__KAU_ TB1 ON TB1.Ref = AR.
		LEFT JOIN [{Variable_TempDb}].dbo.__KAU_ TB2 ON TB2.Ref = AR.
		LEFT JOIN {Variable_WorkDb}.dbo.KAU ON KAU.LINK = coalesce(TB.LINK,TB1.LINK,TB2.LINK)
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[OUT_TABLE_ANALIT] Z WHERE Z.[LINK_ROW] = OT.LINK)

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK
END
GO

-- 
IF exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject|]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	AND exists(select 1 from [{Variable_TempDb}].[dbo].sysobjects where id = object_id('[{Variable_TempDb}].[dbo].[DocumentObject||]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	INSERT [{Variable_WorkDb}].dbo.DOC_BSO_OPER ([LINK_UP], [SOURCE], [SERIES], [RANGE_BEG], [RANGE_END], [RANGE_BEG_C], [RANGE_END_C], [QTY_REQUEST], [QTY_GIVEN], [PRICE_R])
	SELECT
		[LINK_UP] = OT.LINK
		,[SOURCE] = FS.LINK
		,[SERIES] = ISNULL (SBSO.[Description], '')
		,[RANGE_BEG] = [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0))
		,[RANGE_END] = [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0))
		,[RANGE_BEG_C] = right(AR1.,18)
		,[RANGE_END_C] = right(AR1.,18)
		,[QTY_REQUEST] = ([{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., AR1.)) - [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0)) + 1)
		,[QTY_GIVEN] = ([{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., AR1.)) - [{Variable_TempDb}].dbo.getNumeric(ISNULL (AR1., 0)) + 1)
		,[PRICE_R] = 0
	FROM
		[{Variable_TempDb}].dbo.[__G_PROV_] T
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject|] AR ON AR.REF = T.REF
		INNER JOIN [{Variable_TempDb}].dbo.[DocumentObject||] AR1 ON AR.Ref = AR1.Parent_Ref
		INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OT ON OT.[LINK_INS] = AR1.[ROW_ID]

		INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_] do on do.Ref = AR.
		INNER JOIN {Variable_WorkDb}.dbo.V_DEP VD ON VD.LINK = do.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[ChartOfAccountsObject|] accCD ON accCD.Ref = AR.
		left join [{Variable_TempDb}].dbo.[__] k on k.name= ar.
		LEFT JOIN {Variable_WorkDb}.dbo.FIN_SOURCE FS ON k.code = FS.CODE

		LEFT JOIN [{Variable_TempDb}].dbo.[CatalogObject|] SBSO ON (SBSO.REF = AR1.)
	WHERE
		NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[DOC_BSO_OPER] Z WHERE Z.[LINK_UP] = OT.LINK)

	DECLARE @iError INT
	SELECT @iError = @@ERROR
	IF @iError <> 0
		ROLLBACK	
END
GO

COMMIT TRAN

GO


