/*
     
            
*/

set xact_abort ON

BEGIN TRAN
GO

USE [{Variable_WorkDb}]
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO


USE {Variable_TempDb}
GO


UPDATE GAP SET GAP.DEP_ACC = DA.LINK
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] D
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON D.LINK = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP ON GAP.LINK_UP = G2.LINK
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ TC ON TC.LINK = GAP.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS DA ON DA.LINK_UP = TC.LINK
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS__ TD ON TD.LINK = DA.LINK
WHERE
	GAP.DEP IS NOT NULL
	AND
	GAP.DEP_ACC IS NULL	
GO

UPDATE S SET S.DEP_ACC = DA.LINK
FROM
	[{Variable_WorkDb}].dbo.SALDO S
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_ TC ON TC.LINK = S.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS DA ON DA.LINK_UP = TC.LINK
	INNER JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS__ TD ON TD.LINK = DA.LINK
WHERE
	S.ISOBOROT = 2
	AND
	S.DEP IS NOT NULL
	AND
	S.DEP_ACC IS NULL		
GO

----   
UPDATE GAP SET 
	GAP.DEP = otc.SUPPLIER_LINK
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] D
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON D.LINK = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP ON GAP.LINK_UP = G2.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV O ON O.LINK = GAP.AP1
	INNER JOIN [{Variable_WorkDb}].dbo.FINANSE_CONTRACT_HEAD f ON f.LINK_UP = o.link
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d1 ON d1.LINK = O.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_CORR otc ON otc.LINK_UP = O.LINK
WHERE 
	O.[OBJECT] = [{Variable_WorkDb}].dbo.LINK_PF_CONTRACT_SERVICE()
	AND otc.SUPPLIER_LINK IS NOT NULL AND otc.BUYER_LINK IS NOT NULL AND otc.SUPPLIER_LINK <> otc.BUYER_LINK AND (GAP.DEP IS NULL OR GAP.DEP <> otc.SUPPLIER_LINK)

-----    
UPDATE GAP SET 
	GAP.DEP = otc.SUPPLIER_LINK
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] D
	INNER JOIN [{Variable_WorkDb}].dbo.SALDO GAP ON D.LINK = GAP.[DEP_LINK]
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV O ON O.LINK = GAP.AP1
	INNER JOIN [{Variable_WorkDb}].dbo.FINANSE_CONTRACT_HEAD f ON f.LINK_UP = o.link
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d1 ON d1.LINK = GAP.DEP_LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_CORR otc ON otc.LINK_UP = O.LINK
WHERE 
	GAP.ISOBOROT = 2
	AND O.[OBJECT] = [{Variable_WorkDb}].dbo.LINK_PF_CONTRACT_SERVICE()
	AND otc.SUPPLIER_LINK IS NOT NULL AND otc.BUYER_LINK IS NOT NULL AND otc.SUPPLIER_LINK <> otc.BUYER_LINK AND (GAP.DEP IS NULL OR GAP.DEP <> otc.SUPPLIER_LINK)
	--AND d1.INN = '4803004553'
GO


----   
UPDATE GAP SET 
	GAP.AP2 = GR.AP2,
	GAP.NOMEN = GR.NOMEN
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] D
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON D.LINK = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d1 ON d1.LINK = G.DEP
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP ON GAP.LINK_UP = G2.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.PF_SERVICE_REC SR ON GAP.DEP_ACC = SR.DEP_ACC
	INNER JOIN [{Variable_WorkDb}].dbo.PF_SERVICE_REC_GROUP A ON A.LINK_UP = SR.LINK AND GAP.AP1 = A.AP1
		AND CAST(LEFT(CONVERT(CHAR(8), G.[DATE],112),6) AS INT) BETWEEN
		CAST(LEFT(CONVERT(CHAR(8), A.DATE_BEG,112),6) AS INT)
		AND ISNULL(CAST(LEFT(CONVERT(CHAR(8), A.DATE_END,112),6) AS INT),209900)
	INNER JOIN [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] GR ON GR.LINK = A.[GROUP]

GO

-----    
UPDATE GAP SET 
	GAP.AP2 = GR.AP2,
	GAP.NOMEN = GR.NOMEN
FROM
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] D
	INNER JOIN [{Variable_WorkDb}].dbo.SALDO GAP ON D.LINK = GAP.[DEP_LINK]
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d1 ON d1.LINK = GAP.DEP_LINK
	INNER JOIN [{Variable_WorkDb}].dbo.PF_SERVICE_REC SR ON GAP.DEP_ACC = SR.DEP_ACC
	INNER JOIN [{Variable_WorkDb}].dbo.PF_SERVICE_REC_GROUP A ON A.LINK_UP = SR.LINK AND GAP.AP1 = A.AP1
		AND CAST(LEFT(CONVERT(CHAR(8), GAP.[DATE],112),6) AS INT) BETWEEN
		CAST(LEFT(CONVERT(CHAR(8), A.DATE_BEG,112),6) AS INT)
		AND ISNULL(CAST(LEFT(CONVERT(CHAR(8), A.DATE_END,112),6) AS INT),209900)
	INNER JOIN [{Variable_WorkDb}].[dbo].[PF_GROUP_SERVICE_REC] GR ON GR.LINK = A.[GROUP]
WHERE 
	GAP.ISOBOROT = 2

GO

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]
GO

COMMIT TRAN

GO
