USE [{Variable_WorkDb}]
GO

IF OBJECT_ID('TEMPDB..#DATE1', 'U') IS NOT NULL
	DROP TABLE #DATE1
GO

CREATE TABLE #DATE1 (G_PROV INT, MAIN_LINK INT)
GO

-- 
DECLARE @link_DOCUMENTS_OPER INT
SET @link_DOCUMENTS_OPER = [{Variable_WorkDb}].dbo.link_DOCUMENTS_OPER()

INSERT INTO #DATE1 (G_PROV, MAIN_LINK)
SELECT 
	G.LINK, MAIN_LINK = MIN(G.LINK) OVER (PARTITION BY G.DEP, G.NUMBER, G.[DATE], G.[DATE_PROV])
FROM
	[{Variable_WorkDb}].dbo.TYPE_OTHER_OPER T
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_OTHER_OPER GP	ON T.LINK = GP.TYPE_OPER
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON GP.DOC_LINK=G.LINK AND G.[OBJECT] = @link_DOCUMENTS_OPER
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_] gpp ON gpp.LINK1 = g.LINK
WHERE
	T.NAME = ''
GO

set xact_abort on
begin tran
GO

--    
UPDATE G1 SET G1.LINK_UP = A.MAIN_LINK
FROM
	#DATE1 A
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON A.G_PROV = G1.LINK_UP
WHERE
	A.G_PROV <> A.MAIN_LINK
GO

--    
UPDATE G SET G.DATE_PROV = NULL
FROM
	#DATE1 A
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.G_PROV = G.LINK
WHERE
	A.G_PROV <> A.MAIN_LINK
GO

--  
DELETE G
FROM
	#DATE1 A
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.G_PROV = G.LINK
WHERE
	A.G_PROV <> A.MAIN_LINK
GO

--     
UPDATE G SET G.SUMMA = ISNULL(T.SUMMA_PROV,0)
FROM
	#DATE1 A
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.MAIN_LINK = G.LINK
	OUTER APPLY (SELECT SUMMA_PROV = SUM(G2.SUMMA) FROM [{Variable_WorkDb}].dbo.G_PROV1 G1 inner join [{Variable_WorkDb}].dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK WHERE G1.LINK_UP = G.LINK) T
GO

--      
DECLARE @link_DOC_SALARY INT
SET @link_DOC_SALARY = [{Variable_WorkDb}].dbo.link_DOC_SALARY()

UPDATE G SET G.[OBJECT] = @link_DOC_SALARY
FROM
	#DATE1 A
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON A.MAIN_LINK = G.LINK
GO

commit tran
GO

---- 
--IF OBJECT_ID('TEMPDB..#DATE2', 'U') IS NOT NULL
--	DROP TABLE #DATE2
--GO

--CREATE TABLE #DATE2 (LINK INT)
--INSERT INTO #DATE2 (LINK)
--SELECT MAIN_LINK FROM #DATE1 GROUP BY MAIN_LINK

--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KAU @cTempTable = '#DATE2'
--GO

----    .   
--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOP_CLASSIF @cTempTable = '#DATE2'
--GO

----      
--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_EKR @cTempTable = '#DATE2'
--GO

----       
--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_FIN_SOURCE @cTempTable = '#DATE2'
--GO

----      
--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KBK @cTempTable = '#DATE2'
--GO

----    -  
--EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOCBASE @cTempTable = '#DATE2'
--GO
