--     

USE [{Variable_WorkDb}]

set xact_abort on
begin tran
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].[dbo].[__DEPARTMENTS_] A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

--         
SELECT 
	B.AP1,
	cSource = SUBSTRING(B.ACC_CODE,1,1),
	SUMMA = SUM(CASE WHEN SUBSTRING(B.ACC_CODE,7,1) = '1' THEN A.SUMMA ELSE 0 END),
	SUMMA2 = SUM(CASE WHEN SUBSTRING(B.ACC_CODE,7,1) = '2' THEN A.SUMMA ELSE 0 END),
	SUMMA3 = SUM(CASE WHEN SUBSTRING(B.ACC_CODE,7,1) = '3' THEN A.SUMMA ELSE 0 END),
	SUMMA4 = SUM(CASE WHEN SUBSTRING(B.ACC_CODE,7,1) = '4' THEN A.SUMMA ELSE 0 END),
	SUMMA5 = SUM(CASE WHEN SUBSTRING(B.ACC_CODE,7,1) > '4' THEN A.SUMMA ELSE 0 END),
	B.KBK, 
	B.SGU,
	B.AP2,
	B.KAU
INTO 
	#DOG_INFO
FROM
	{Variable_TempDb}.[dbo].[__PROV_HDR_1C] A
	INNER JOIN {Variable_TempDb}.[dbo].[__PROV_ANALIT_1C] B ON A.LINK = B.LINK_UP AND B.DB_KR = 1 AND ACC_CODE LIKE '_.502._1'
GROUP BY
	B.AP1, B.ACC_CODE, B.KBK, B.SGU, B.AP2, B.KAU
HAVING
	B.AP1 IS NOT NULL
GO

--     1     --    
INSERT INTO {Variable_WorkDb}.dbo.FINANSE_CONTRACT WITH (ROWLOCK) 
(
	LINK_UP		
	,RECORD_NO, RECORD_CH_NO
	,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12
	,OKDP,QUANTITY, COST			
	,[SOURCE], VKR,EKR, KAU_LINK, DOP_CLASSIF, KL_REG_LINK, NOMEN
	,ORDERS
	,STAVKA_NDS,NO_NDS,SUMMA_NDS
	,SUMMA, SUMMA_2,SUMMA_3,SUMMA_4,SUMMA_5,SUMMA_ALL
	,NOMEN_TYPE
	,DEP_ACC_LINK
	,NUMBER_BO
	,DATE_BO
)
SELECT
	LINK_UP =  I.AP1
	,RECORD_NO = '', RECORD_CH_NO = NULL
	,P1 = 0, P2 = 0, P3 = 0, P4 = 0, P5 = 0, P6 = 0, P7 = 0, P8 = 0, P9 = 0, P10 = 0, P11 = 0, P12 = 0
	,OKDP = NULL, QUANTITY = 0, COST = 0	
	,[SOURCE] = S.LINK, VKR = KBK, EKR = SGU, KAU_LINK = KAU, DOP_CLASSIF = AP2, KL_REG_LINK = NULL, NOMEN = NULL
	,ORDERS = 1
	,STAVKA_NDS = 0, NO_NDS = 0, SUMMA_NDS = 0
	,SUMMA = SUMMA, SUMMA_2 = SUMMA2, SUMMA_3 = SUMMA3, SUMMA_4 = SUMMA4, SUMMA_5 = SUMMA5, SUMMA_ALL = SUMMA + SUMMA2 + SUMMA3 + SUMMA4 + SUMMA5
	,NOMEN_TYPE = NULL
	,DEP_ACC_LINK = NULL
	,NUMBER_BO = NULL
	,DATE_BO = NULL
FROM 
	#DOG_INFO I
	INNER JOIN {Variable_WorkDb}.dbo.FIN_SOURCE S ON S.CODE = [cSource]
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.FINANSE_CONTRACT fh WHERE fh.link_up = I.AP1)
ORDER BY
	AP1
GO

--   
UPDATE G SET G.SUMMA = T.SUM_ALL
FROM
	(SELECT
		AP1
		,SUM_ALL = SUM(SUMMA) + SUM(SUMMA2) + SUM(SUMMA3) + SUM(SUMMA4) + SUM(SUMMA5)
	FROM
		#DOG_INFO
	GROUP BY
		AP1
	) T
	INNER JOIN {Variable_WorkDb}.dbo.G_PROV G ON G.LINK = T.AP1
GO

--   
UPDATE G SET G.SUMMA_F = T.SUMMA
FROM
	(SELECT
		AP1
		,SUMMA = SUM(SUMMA)
	FROM
		#DOG_INFO
	GROUP BY
		AP1
	) T
	INNER JOIN {Variable_WorkDb}.dbo.FINANSE_CONTRACT_HEAD G ON G.LINK_UP = T.AP1
GO

--  = 
DECLARE @iDOC_OPER_LINk	INT
SET @iDOC_OPER_LINk = (SELECT TOP 1 LINK FROM {Variable_WorkDb}.dbo.DOC_OPERS WHERE CODE = 'FIN_CONTR_ACCEPTED_BO')

INSERT INTO {Variable_WorkDb}.dbo.G_PROV_DOC_OPER ( LINK_UP, DOC_OPER )
SELECT AP1, @iDOC_OPER_LINk
FROM (SELECT AP1 FROM #DOG_INFO GROUP BY AP1) T	
WHERE NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.G_PROV_DOC_OPER WHERE LINK_UP = AP1)
GO

--
INSERT INTO {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] ([LINK_UP])
SELECT AP1 FROM #DOG_INFO WHERE NOT EXISTS (SELECT * FROM {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] WHERE LINK_UP = AP1 ) GROUP BY AP1

----      ,      G_PROV_FIELDS
CREATE TABLE #tKAU (LINK_DOC INT,LINK_KAU INT)

INSERT INTO #tKAU
SELECT AP1, KAU FROM #DOG_INFO WHERE  KAU IS NOT NULL GROUP BY AP1, KAU

UPDATE G SET
	[KAU_CODES] = 
			SUBSTRING((
				SELECT DISTINCT ',' + LTRIM(RTRIM(D.CODE))
					FROM #tKAU V INNER JOIN {Variable_WorkDb}.dbo.KAU D ON V.LINK_KAU = D.LINK
					WHERE V.LINK_DOC = G.[LINK_UP]
					ORDER BY ',' + LTRIM(RTRIM(D.CODE))
				FOR XML PATH('')
			), 2, 3000)
FROM 
	(SELECT AP1 FROM #DOG_INFO WHERE KAU IS NOT NULL GROUP BY AP1) T
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] G ON T.AP1 = G.[LINK_UP]
GO

----    .   ,      G_PROV_FIELDS
CREATE TABLE #tDOP (LINK_DOC INT, LINK_DOP_CLASSIF INT)

INSERT INTO #tDOP
SELECT AP1, AP2 FROM #DOG_INFO WHERE AP2 IS NOT NULL GROUP BY AP1, AP2
			
UPDATE G SET
	[DOP_CLASSIF_CODES] = 
			SUBSTRING((
				SELECT DISTINCT ',' + LTRIM(RTRIM(D.CODE))
					FROM #tDOP V INNER JOIN {Variable_WorkDb}.dbo.DOP_CLASSIF D ON V.LINK_DOP_CLASSIF = D.LINK
					WHERE V.LINK_DOC = G.[LINK_UP]
					ORDER BY ',' + LTRIM(RTRIM(D.CODE))
				FOR XML PATH('')
			), 2, 3000)
FROM 
	(SELECT AP1 FROM #DOG_INFO WHERE AP2 IS NOT NULL GROUP BY AP1) T
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] G ON T.AP1 = G.[LINK_UP]
GO
			
--      ,      G_PROV_FIELDS
CREATE TABLE #tEKR (LINK_DOC INT,EKR_CODES INT)

INSERT INTO #tEKR
SELECT AP1, SGU FROM #DOG_INFO WHERE SGU IS NOT NULL GROUP BY AP1, SGU
			
UPDATE G SET
	EKR_CODES = 
			SUBSTRING((
				SELECT DISTINCT ',' + LTRIM(RTRIM(D.CODE))
					FROM #tEKR V INNER JOIN {Variable_WorkDb}.dbo.KOSGU D ON V.EKR_CODES = D.LINK
					WHERE V.LINK_DOC = G.[LINK_UP]
					ORDER BY ',' + LTRIM(RTRIM(D.CODE))
				FOR XML PATH('')
			), 2, 3000)
FROM 
	(SELECT AP1 FROM #DOG_INFO WHERE SGU IS NOT NULL GROUP BY AP1) T
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] G ON T.AP1 = G.[LINK_UP]
GO

----       ,      G_PROV_FIELDS
CREATE TABLE #tSRC (LINK_DOC INT, FIN_SOURCE_CODES VARCHAR(1))

INSERT INTO #tSRC
SELECT AP1, cSource FROM #DOG_INFO WHERE cSource IS NOT NULL GROUP BY AP1, cSource
			
UPDATE G SET
	FIN_SOURCE_CODES = 
			SUBSTRING((
				SELECT DISTINCT ',' + LTRIM(RTRIM(V.FIN_SOURCE_CODES))
					FROM #tSRC V
					WHERE V.LINK_DOC = G.[LINK_UP]
					ORDER BY ',' + LTRIM(RTRIM(V.FIN_SOURCE_CODES))
				FOR XML PATH('')
			), 2, 3000)
FROM 
	(SELECT AP1 FROM #DOG_INFO WHERE cSource IS NOT NULL GROUP BY AP1) T
	INNER JOIN {Variable_WorkDb}.[dbo].[G_PROV_FIELDS] G ON T.AP1 = G.[LINK_UP]
GO

--         
update t set t.NUMBER_BO = left(h.BO_NUMS,19)
from
	[{Variable_TempDb}].dbo.[__G_PROV_] r
	inner join {Variable_WorkDb}.dbo.G_PROV g on g.link = r.link
	inner join {Variable_WorkDb}.dbo.FINANSE_CONTRACT_HEAD h on h.LINK_UP = g.link
	inner join {Variable_WorkDb}.dbo.FINANSE_CONTRACT t on t.LINK_UP = g.link
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]
GO

commit tran
GO
