USE [{Variable_TempDb}]
GO

SET XACT_ABORT ON 

BEGIN TRAN

DECLARE
	@SQL_EXEC	VARCHAR (8000)

IF OBJECT_ID ('TEMPDB..#ASSETS_UPD') IS NOT NULL
	EXEC ('DROP TABLE #ASSETS_UPD')

CREATE TABLE #ASSETS_UPD
	(
	LINK INT,
	PER_USED	INT,
	PER_USED_AM	INT,
	DATE_CALC_AM	DATETIME,
	DATE_REST	DATETIME
	)

IF EXISTS (SELECT * FROM dbo.[SYSOBJECTS]
			WHERE ID = OBJECT_ID ('[dbo].[InformationRegisterRecordSet|]')
				AND OBJECTPROPERTY(id, N'IsUserTable') = 1
			)
BEGIN
	SET @SQL_EXEC =
'
INSERT INTO #ASSETS_UPD
	(
	LINK,
	PER_USED,
	PER_USED_AM,
	DATE_CALC_AM,
	DATE_REST
	)
SELECT
	B.LINK,
'
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[],'
		ELSE 'NULL,'
	END
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[],'
		ELSE 'NULL,'
	END
	+
'
	DATEADD (DAY, DATEDIFF (DAY, 0, C.PERIOD), 0),
	T1.[DATE]
FROM [dbo].[__INVENTORY__] B
INNER JOIN [dbo].[InformationRegisterRecordSet|] C ON '
	+
	CASE
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[] = B.INSERTED_UIDS'
		WHEN Exists(select 1 from sys.columns where Name = N''
				and Object_ID = Object_ID(N'[dbo].[InformationRegisterRecordSet|]'))
			THEN 'C.[] = B.INSERTED_UIDS'
	END
	+
'
INNER JOIN
	(
	SELECT
		S.INV,
		S.[DATE],
		REC_NO = ROW_NUMBER () OVER (PARTITION BY S.INV ORDER BY S.[DATE])
	FROM [{Variable_WorkDb}].dbo.SALDO S
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS SA ON
		SA.LINK = S.ACCOUNT
		AND SA.cSINTH = ''101''
	WHERE S.ISOBOROT = 2
	) AS T1 ON
		T1.INV = B.LINK
		AND T1.REC_NO = 1
WHERE C.ACTIVE = ''True''
	AND C.[] > 0
'
	EXEC (@SQL_EXEC)
END

USE [{Variable_WorkDb}]
GO

UPDATE A
SET 
	DEPRE_DATE_CALC = DATEADD (DAY, 1, B.DATE_REST),
	LAST_PER_USED = B.PER_USED - DATEDIFF (MONTH, A.DATE_COME, B.DATE_REST) 
FROM dbo.ASSETS A
INNER JOIN #ASSETS_UPD B ON B.LINK = A.LINK_UP
WHERE B.PER_USED > DATEDIFF (MONTH, A.DATE_COME, B.DATE_REST) 

IF OBJECT_ID ('TEMPDB..#ASSETS_UPD') IS NOT NULL
	EXEC ('DROP TABLE #ASSETS_UPD')

COMMIT TRAN

GO
