SET NOCOUNT ON
SET XACT_ABORT ON
GO

USE [{Variable_WorkDb}]
GO

BEGIN TRAN
--   --
IF OBJECT_ID ('TEMPDB..#tINV_GRP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_GRP')

CREATE TABLE #tINV_GRP
	(
	LINK		INT,
	INV_MAIN	INT
	)

INSERT INTO #tINV_GRP
	(
	LINK,
	INV_MAIN
	)
SELECT
	IGR.INV_DEPEND,
	IGR.INV_MAIN
FROM dbo.INVENTORY_GRP_LIST IGR 
INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY__] INV1 ON
	INV1.LINK = IGR.INV_DEPEND
WHERE
	NOT EXISTS
		(
		SELECT 1 FROM [{Variable_TempDb}].dbo.[InformationRegisterRecordSet|] TTT
		WHERE
			TTT. = INV1.REF
			AND TTT. = ''
		)

--SELECT '#tINV_GRP', * FROM #tINV_GRP

--  --
--     --
IF OBJECT_ID ('TEMPDB..#tSALDO') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO')

CREATE TABLE #tSALDO
	(
	LINK	INT,
	INV	INT,
	D_SUMMA	NUMERIC (28,4),
	QTY	NUMERIC (28,4),
	PRICE	NUMERIC (28,4),
	ZABALANS	TINYINT
	)

INSERT INTO #tSALDO
	(
	LINK,
	INV,
	D_SUMMA,
	QTY,
	PRICE,
	ZABALANS
	)
SELECT
	S.LINK,
	S.INV,
	S.D_SUMMA,
	S.D_QUANTITY,
	S.D_SUMMA / S.D_QUANTITY,
	SA.ZABALANS
FROM dbo.SALDO S
INNER JOIN dbo.S_ACCOUNTS SA ON
	SA.LINK = S.ACCOUNT
	AND SA.KSU = 1
	AND (
		SA.ZABALANS = 0 AND SA.cSINTH LIKE '10[1238]'
		OR SA.ZABALANS = 1 
		)
	AND S.ISOBOROT = 2

INNER JOIN dbo.ASSETS A ON
	A.LINK_UP = S.INV
	AND A.GRP_CALC = 1
	AND S.D_QUANTITY > 1
INNER JOIN 
	(
	SELECT
		INV_GR = INV_MAIN,
		QTY = COUNT (*) + 1
	FROM dbo.INVENTORY_GRP_LIST 
	GROUP BY
		INV_MAIN
	) AS T1 ON 
		T1.INV_GR = S.INV
		AND T1.QTY >= S.D_QUANTITY

--SELECT '#tSALDO', * FROM #tSALDO

INSERT INTO dbo.SALDO
	(
	[DATE], ACCOUNT, D_SUMMA, K_SUMMA, R_SUMMA,
	D_QUANTITY, K_QUANTITY, ISOBOROT, KBK, EKR,
	DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC,
	TMC, INDATE, SGU,
	AP1, AP2, AP3, AP4, AP5, AP6,
	DEP_LINK, PRICE, LINK_DOC
	)
SELECT
	S.[DATE], S.ACCOUNT,
	D_SUMMA = S1.PRICE, 
	S.K_SUMMA, S.R_SUMMA,
	D_QUANTITY = 1, 
	S.K_QUANTITY, S.ISOBOROT,
	S.KBK, S.EKR, S.DEP, S.SUB, S.EMP, S.NOMEN,
	INV = IGR.LINK, 
	S.KAU, S.DEP_ACC, S.TMC, S.INDATE,
	S.SGU, S.AP1, S.AP2, S.AP3, S.AP4, S.AP5, S.AP6,
	S.DEP_LINK, S.PRICE, S.LINK_DOC
FROM dbo.SALDO S
INNER JOIN #tSALDO S1 ON S1.LINK = S.LINK

INNER JOIN #tINV_GRP IGR ON IGR.INV_MAIN = S.INV
WHERE NOT EXISTS
			(
			SELECT 1 FROM dbo.SALDO SSS
			WHERE SSS.INV = IGR.LINK
				AND SSS.ACCOUNT = S.ACCOUNT
				AND SSS.ISOBOROT = S.ISOBOROT
			)

UPDATE S
SET
	D_SUMMA = S1.PRICE,
	D_QUANTITY = 1
FROM dbo.SALDO S
INNER JOIN #tSALDO S1 ON S1.LINK = S.LINK

--  --
--     --
IF OBJECT_ID ('TEMPDB..#tSALDO_A') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO_A')

CREATE TABLE #tSALDO_A
	(
	LINK	INT,
	K_SUMMA	NUMERIC (28,4),
	PRICE	NUMERIC (28,4)
	)

INSERT INTO #tSALDO_A
	(
	LINK,
	K_SUMMA,
	PRICE
	)
SELECT
	S.LINK,
	S.K_SUMMA,
	S.K_SUMMA / S1.QTY 
FROM dbo.SALDO S
INNER JOIN dbo.S_ACCOUNTS SA ON
	SA.LINK = S.ACCOUNT
	AND SA.ZABALANS = 0 AND SA.cSINTH = '104'
	AND S.ISOBOROT = 2

INNER JOIN #tSALDO S1 ON
	S1.INV = S.INV
	AND S1.ZABALANS = 0

--SELECT '#tSALDO_A', * FROM #tSALDO_A

INSERT INTO dbo.SALDO
	(
	[DATE], ACCOUNT, D_SUMMA, K_SUMMA, R_SUMMA,
	D_QUANTITY, K_QUANTITY, ISOBOROT, KBK, EKR,
	DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC,
	TMC, INDATE, SGU,
	AP1, AP2, AP3, AP4, AP5, AP6,
	DEP_LINK, PRICE, LINK_DOC
	)
SELECT
	S.[DATE], S.ACCOUNT,
	S.D_SUMMA,
	K_SUMMA = S1.PRICE, 
	S.R_SUMMA,
	S.D_QUANTITY,
	S.K_QUANTITY,
	S.ISOBOROT,
	S.KBK, S.EKR, S.DEP, S.SUB, S.EMP, S.NOMEN,
	INV = IGR.LINK, 
	S.KAU, S.DEP_ACC, S.TMC, S.INDATE,
	S.SGU, S.AP1, S.AP2, S.AP3, S.AP4, S.AP5, S.AP6,
	S.DEP_LINK, S.PRICE, S.LINK_DOC
FROM dbo.SALDO S
INNER JOIN #tSALDO_A S1 ON S1.LINK = S.LINK

INNER JOIN #tINV_GRP IGR ON IGR.INV_MAIN = S.INV
WHERE NOT EXISTS
			(
			SELECT 1 FROM dbo.SALDO SSS
			WHERE SSS.INV = IGR.LINK
				AND SSS.ACCOUNT = S.ACCOUNT
				AND SSS.ISOBOROT = S.ISOBOROT
			)

UPDATE S
SET
	K_SUMMA = S1.PRICE
FROM dbo.SALDO S
INNER JOIN #tSALDO_A S1 ON S1.LINK = S.LINK

IF OBJECT_ID ('TEMPDB..#tSALDO') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO')

IF OBJECT_ID ('TEMPDB..#tSALDO_A') IS NOT NULL
	EXEC ('DROP TABLE #tSALDO_A')

IF OBJECT_ID ('TEMPDB..#tINV_GRP') IS NOT NULL
	EXEC ('DROP TABLE #tINV_GRP')

COMMIT TRAN

GO

