USE [{Variable_WorkDb}]
GO

/*
   "  "
       

SELECT LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B, COUNT(*)
FROM
	dbo.GROUP_ACTIVE B
GROUP BY
	LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B
HAVING
	COUNT(*) > 1

*/

set xact_abort on
BEGIN TRAN

SET NOCOUNT ON

declare @RID UniqueIdentifier
execute dbo.newrid @RID=@RID output

DECLARE @CODE_GRP VARCHAR(254), @NAME VARCHAR(2000), @LINK_DEP INT, @LINK INT, @LINK_SELF INT, @ACCOUNT_B INT

DECLARE @Cur1 CURSOR

SET @Cur1 = CURSOR FORWARD_ONLY

FOR 

	SELECT 
		LINK_DEP, LINK, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B
	FROM
		(
		SELECT LINK, LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B ORDER BY [SYSTEM] DESC, [TYPE], [LINK] ASC)
		FROM
			dbo.GROUP_ACTIVE A
		WHERE
			EXISTS ( SELECT LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B
						FROM
							dbo.GROUP_ACTIVE B
						WHERE
							B.LINK_DEP = A.LINK_DEP
							AND
							B.CODE_GRP = A.CODE_GRP	
							AND
							ISNULL(B.NAME,'') = ISNULL(A.NAME,'')
							AND
							ISNULL(B.LINK_SELF,0) = ISNULL(A.LINK_SELF,0)
							AND
							ISNULL(B.ACCOUNT_B,0) = ISNULL(A.ACCOUNT_B,0)
						GROUP BY
							LINK_DEP, CODE_GRP, NAME, LINK_SELF, ACCOUNT_B
						HAVING
							COUNT(*) > 1
					)
		
		) T 
	WHERE
		T.NUM = 1	
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_GRP, @NAME, @LINK_SELF, @ACCOUNT_B
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		PRINT @CODE_GRP
		
		insert into dbo.sys_link ([rid], [link]) 
		SELECT @RID, T.LINK FROM dbo.GROUP_ACTIVE T WHERE T.LINK_DEP = @LINK_DEP AND T.CODE_GRP = @CODE_GRP AND ISNULL(T.NAME,'') = ISNULL(@NAME,'') AND ISNULL(T.LINK_SELF,0) = ISNULL(@LINK_SELF,0) AND ISNULL(T.ACCOUNT_B,0) = ISNULL(@ACCOUNT_B,0)
		
		exec dbo.XA_MERGE_REC @OBJ_CODE = 'DICT_GROUP_ACTIVE', @nMainLink = @LINK, @RID = @RID
		
		DELETE FROM dbo.sys_link WHERE [rid] = @RID
		
	END

	FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_GRP, @NAME, @LINK_SELF, @ACCOUNT_B
END

CLOSE @Cur1
DEALLOCATE @Cur1

SET NOCOUNT OFF

COMMIT TRAN
GO
