
/*
   " "

SELECT NAME, COUNT(*)
FROM
	dbo.CHARACTERISTICS B
GROUP BY
	NAME
HAVING
	COUNT(*) > 1
*/

USE [{Variable_WorkDb}]
GO

set xact_abort on
BEGIN TRAN

SET NOCOUNT ON

declare @RID UniqueIdentifier
execute dbo.newrid @RID=@RID output

DECLARE @LINK INT, @LINK_DEP INT, @SYSTEM INT, @CODE VARCHAR(10), @NAME VARCHAR(254)
 
DECLARE @Cur1 CURSOR

SET @Cur1 = CURSOR FORWARD_ONLY

FOR 

	SELECT 
		LINK, NAME
	FROM
		(
		SELECT 
			LINK, [SYSTEM], NAME,
			NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY [SYSTEM] DESC, LINK ASC),
			CNT = COUNT(*) OVER (PARTITION BY NAME)
		FROM
			dbo.CHARACTERISTICS A
		) T 
	WHERE
		T.NUM = 1 AND CNT > 1	
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK, @NAME
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		PRINT @NAME
		
		insert into dbo.sys_link ([rid], [link]) 
		SELECT @RID, T.LINK FROM dbo.CHARACTERISTICS T WHERE T.NAME = @NAME 
		
		exec dbo.XA_MERGE_REC @OBJ_CODE = 'BV_CHARACTERS_DIC', @nMainLink = @LINK, @RID = @RID
		
		DELETE FROM dbo.sys_link WHERE [rid] = @RID
		
	END

	FETCH NEXT FROM @Cur1 INTO @LINK, @NAME
END

CLOSE @Cur1
DEALLOCATE @Cur1

--------------

SET NOCOUNT OFF

GO

COMMIT TRAN
GO

